/****************************************************************************
**
** Copyright (C) 2024 MikroElektronika d.o.o.
** Contact: https://www.mikroe.com/contact
**
** This file is part of the mikroSDK package
**
** Commercial License Usage
**
** Licensees holding valid commercial NECTO compilers AI licenses may use this
** file in accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The MikroElektronika Company.
** For licensing terms and conditions see
** https://www.mikroe.com/legal/software-license-agreement.
** For further information use the contact form at
** https://www.mikroe.com/contact.
**
**
** GNU Lesser General Public License Usage
**
** Alternatively, this file may be used for
** non-commercial projects under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** The above copyright notice and this permission notice shall be
** included in all copies or substantial portions of the Software.
**
** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
** OF MERCHANTABILITY, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
** TO THE WARRANTIES FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
** DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
** OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
**
****************************************************************************/
/*!
 * @file  shield.h
 * @brief Mikromedia shield connections mapping.
 */

#ifndef _SHIELD_H_
#define _SHIELD_H_

#ifdef __cplusplus
extern "C"{
#endif

#include "mikrobus.h"

// Shield header connections
#define SHIELD_CONNECTOR_HDR1_PIN1 HAL_PIN_NC  // VCC 5V
#define SHIELD_CONNECTOR_HDR1_PIN2 HAL_PIN_NC  // VDD
#define SHIELD_CONNECTOR_HDR1_PIN3 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN4 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN5 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN6 HEADER_CONNECTOR_HDR1_PIN6
#define SHIELD_CONNECTOR_HDR1_PIN7 HEADER_CONNECTOR_HDR1_PIN7
#define SHIELD_CONNECTOR_HDR1_PIN8 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN9 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN10 HEADER_CONNECTOR_HDR2_PIN10
#define SHIELD_CONNECTOR_HDR1_PIN11 HEADER_CONNECTOR_HDR2_PIN11
#define SHIELD_CONNECTOR_HDR1_PIN12 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN13 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN14 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN15 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN16 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN17 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN18 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN19 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN20 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN21 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR1_PIN22 HEADER_CONNECTOR_HDR1_PIN22
#define SHIELD_CONNECTOR_HDR1_PIN23 HEADER_CONNECTOR_HDR1_PIN23
#define SHIELD_CONNECTOR_HDR1_PIN24 HEADER_CONNECTOR_HDR1_PIN24
#define SHIELD_CONNECTOR_HDR1_PIN25 HAL_PIN_NC  // VCC 3V3
#define SHIELD_CONNECTOR_HDR1_PIN26 HAL_PIN_NC  // VDD

#define SHIELD_CONNECTOR_HDR2_PIN27 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN28 HAL_PIN_NC  // VDD
#define SHIELD_CONNECTOR_HDR2_PIN29 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN30 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN31 HEADER_CONNECTOR_HDR2_PIN31
#define SHIELD_CONNECTOR_HDR2_PIN32 HEADER_CONNECTOR_HDR2_PIN32
#define SHIELD_CONNECTOR_HDR2_PIN33 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN34 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN35 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN36 HEADER_CONNECTOR_HDR2_PIN36
#define SHIELD_CONNECTOR_HDR2_PIN37 HEADER_CONNECTOR_HDR2_PIN37
#define SHIELD_CONNECTOR_HDR2_PIN38 HEADER_CONNECTOR_HDR2_PIN38
#define SHIELD_CONNECTOR_HDR2_PIN39 HEADER_CONNECTOR_HDR2_PIN39
#define SHIELD_CONNECTOR_HDR2_PIN40 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN41 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN42 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN43 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN44 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN45 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN46 HAL_PIN_NC
#define SHIELD_CONNECTOR_HDR2_PIN47 HEADER_CONNECTOR_HDR2_PIN47
#define SHIELD_CONNECTOR_HDR2_PIN48 HEADER_CONNECTOR_HDR2_PIN48
#define SHIELD_CONNECTOR_HDR2_PIN49 HEADER_CONNECTOR_HDR2_PIN49
#define SHIELD_CONNECTOR_HDR2_PIN50 HEADER_CONNECTOR_HDR2_PIN50
#define SHIELD_CONNECTOR_HDR2_PIN51 HAL_PIN_NC  // VCC 3V3
#define SHIELD_CONNECTOR_HDR2_PIN52 HAL_PIN_NC  // VDD

// Shield existing connections
#define SHIELD_CONNECTOR_G01 SHIELD_CONNECTOR_HDR1_PIN6
#define SHIELD_CONNECTOR_G02 SHIELD_CONNECTOR_HDR1_PIN7
#define SHIELD_CONNECTOR_G05 SHIELD_CONNECTOR_HDR1_PIN10
#define SHIELD_CONNECTOR_G06 SHIELD_CONNECTOR_HDR1_PIN11
#define SHIELD_CONNECTOR_G21 SHIELD_CONNECTOR_HDR1_PIN22
#define SHIELD_CONNECTOR_G22 SHIELD_CONNECTOR_HDR1_PIN23
#define SHIELD_CONNECTOR_G23 SHIELD_CONNECTOR_HDR1_PIN24
#define SHIELD_CONNECTOR_G24 SHIELD_CONNECTOR_HDR2_PIN31
#define SHIELD_CONNECTOR_G25 SHIELD_CONNECTOR_HDR2_PIN32
#define SHIELD_CONNECTOR_G31 SHIELD_CONNECTOR_HDR2_PIN36
#define SHIELD_CONNECTOR_G32 SHIELD_CONNECTOR_HDR2_PIN37
#define SHIELD_CONNECTOR_G33 SHIELD_CONNECTOR_HDR2_PIN38
#define SHIELD_CONNECTOR_G34 SHIELD_CONNECTOR_HDR2_PIN39
#define SHIELD_CONNECTOR_G44 SHIELD_CONNECTOR_HDR2_PIN47
#define SHIELD_CONNECTOR_G45 SHIELD_CONNECTOR_HDR2_PIN48
#define SHIELD_CONNECTOR_G46 SHIELD_CONNECTOR_HDR2_PIN49
#define SHIELD_CONNECTOR_G47 SHIELD_CONNECTOR_HDR2_PIN50

// Backwards compatible for code using Jx macros
#define SHIELD_CONNECTOR_J1_PIN6 SHIELD_CONNECTOR_HDR1_PIN6
#define SHIELD_CONNECTOR_J1_PIN7 SHIELD_CONNECTOR_HDR1_PIN7
#define SHIELD_CONNECTOR_J1_PIN10 SHIELD_CONNECTOR_HDR1_PIN10
#define SHIELD_CONNECTOR_J1_PIN11 SHIELD_CONNECTOR_HDR1_PIN11
#define SHIELD_CONNECTOR_J1_PIN22 SHIELD_CONNECTOR_HDR1_PIN22
#define SHIELD_CONNECTOR_J1_PIN23 SHIELD_CONNECTOR_HDR1_PIN23
#define SHIELD_CONNECTOR_J1_PIN24 SHIELD_CONNECTOR_HDR1_PIN24
#define SHIELD_CONNECTOR_J2_PIN5 SHIELD_CONNECTOR_HDR2_PIN31
#define SHIELD_CONNECTOR_J2_PIN6 SHIELD_CONNECTOR_HDR2_PIN32
#define SHIELD_CONNECTOR_J2_PIN10 SHIELD_CONNECTOR_HDR2_PIN36
#define SHIELD_CONNECTOR_J2_PIN11 SHIELD_CONNECTOR_HDR2_PIN37
#define SHIELD_CONNECTOR_J2_PIN12 SHIELD_CONNECTOR_HDR2_PIN38
#define SHIELD_CONNECTOR_J2_PIN13 SHIELD_CONNECTOR_HDR2_PIN39
#define SHIELD_CONNECTOR_J2_PIN21 SHIELD_CONNECTOR_HDR2_PIN47
#define SHIELD_CONNECTOR_J2_PIN22 SHIELD_CONNECTOR_HDR2_PIN48
#define SHIELD_CONNECTOR_J2_PIN23 SHIELD_CONNECTOR_HDR2_PIN49
#define SHIELD_CONNECTOR_J2_PIN24 SHIELD_CONNECTOR_HDR2_PIN50

// MikroBUS definitions
#define SHIELD_MIKROBUS_1_AN   SHIELD_CONNECTOR_HDR1_PIN6
#define SHIELD_MIKROBUS_1_RST  SHIELD_CONNECTOR_HDR2_PIN36
#define SHIELD_MIKROBUS_1_CS   SHIELD_CONNECTOR_HDR2_PIN37
#define SHIELD_MIKROBUS_1_SCK  SHIELD_CONNECTOR_HDR1_PIN22
#define SHIELD_MIKROBUS_1_MISO SHIELD_CONNECTOR_HDR1_PIN23
#define SHIELD_MIKROBUS_1_MOSI SHIELD_CONNECTOR_HDR1_PIN24
#define SHIELD_MIKROBUS_1_PWM  SHIELD_CONNECTOR_HDR2_PIN31
#define SHIELD_MIKROBUS_1_INT  SHIELD_CONNECTOR_HDR1_PIN10
#define SHIELD_MIKROBUS_1_RX   SHIELD_CONNECTOR_HDR2_PIN47
#define SHIELD_MIKROBUS_1_TX   SHIELD_CONNECTOR_HDR2_PIN48
#define SHIELD_MIKROBUS_1_SCL  SHIELD_CONNECTOR_HDR2_PIN49
#define SHIELD_MIKROBUS_1_SDA  SHIELD_CONNECTOR_HDR2_PIN50

#define SHIELD_MIKROBUS_2_AN   SHIELD_CONNECTOR_HDR1_PIN7
#define SHIELD_MIKROBUS_2_RST  SHIELD_CONNECTOR_HDR2_PIN38
#define SHIELD_MIKROBUS_2_CS   SHIELD_CONNECTOR_HDR2_PIN39
#define SHIELD_MIKROBUS_2_SCK  SHIELD_CONNECTOR_HDR1_PIN22
#define SHIELD_MIKROBUS_2_MISO SHIELD_CONNECTOR_HDR1_PIN23
#define SHIELD_MIKROBUS_2_MOSI SHIELD_CONNECTOR_HDR1_PIN24
#define SHIELD_MIKROBUS_2_PWM  SHIELD_CONNECTOR_HDR2_PIN32
#define SHIELD_MIKROBUS_2_INT  SHIELD_CONNECTOR_HDR1_PIN11
#define SHIELD_MIKROBUS_2_RX   SHIELD_CONNECTOR_HDR2_PIN47
#define SHIELD_MIKROBUS_2_TX   SHIELD_CONNECTOR_HDR2_PIN48
#define SHIELD_MIKROBUS_2_SCL  SHIELD_CONNECTOR_HDR2_PIN49
#define SHIELD_MIKROBUS_2_SDA  SHIELD_CONNECTOR_HDR2_PIN50

#define MIKROBUS_1 1
#define MIKROBUS_1_AN   SHIELD_MIKROBUS_1_AN
#define MIKROBUS_1_RST  SHIELD_MIKROBUS_1_RST
#define MIKROBUS_1_CS   SHIELD_MIKROBUS_1_CS
#define MIKROBUS_1_SCK  SHIELD_MIKROBUS_1_SCK
#define MIKROBUS_1_MISO SHIELD_MIKROBUS_1_MISO
#define MIKROBUS_1_MOSI SHIELD_MIKROBUS_1_MOSI
#define MIKROBUS_1_PWM  SHIELD_MIKROBUS_1_PWM
#define MIKROBUS_1_RX   SHIELD_MIKROBUS_1_RX
#define MIKROBUS_1_INT  SHIELD_MIKROBUS_1_INT
#define MIKROBUS_1_TX   SHIELD_MIKROBUS_1_TX
#define MIKROBUS_1_SCL  SHIELD_MIKROBUS_1_SCL
#define MIKROBUS_1_SDA  SHIELD_MIKROBUS_1_SDA

#define MIKROBUS_2 2
#define MIKROBUS_2_AN   SHIELD_MIKROBUS_2_AN
#define MIKROBUS_2_RST  SHIELD_MIKROBUS_2_RST
#define MIKROBUS_2_CS   SHIELD_MIKROBUS_2_CS
#define MIKROBUS_2_SCK  SHIELD_MIKROBUS_2_SCK
#define MIKROBUS_2_MISO SHIELD_MIKROBUS_2_MISO
#define MIKROBUS_2_MOSI SHIELD_MIKROBUS_2_MOSI
#define MIKROBUS_2_PWM  SHIELD_MIKROBUS_2_PWM
#define MIKROBUS_2_RX   SHIELD_MIKROBUS_2_RX
#define MIKROBUS_2_INT  SHIELD_MIKROBUS_2_INT
#define MIKROBUS_2_TX   SHIELD_MIKROBUS_2_TX
#define MIKROBUS_2_SCL  SHIELD_MIKROBUS_2_SCL
#define MIKROBUS_2_SDA  SHIELD_MIKROBUS_2_SDA

#ifdef __cplusplus
}
#endif

#endif // _SHIELD_H_
// ------------------------------------------------------------------------- END
