/****************************************************************************
**
** Copyright (C) 2024 MikroElektronika d.o.o.
** Contact: https://www.mikroe.com/contact
**
** This file is part of the mikroSDK package
**
** Commercial License Usage
**
** Licensees holding valid commercial NECTO compilers AI licenses may use this
** file in accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The MikroElektronika Company.
** For licensing terms and conditions see
** https://www.mikroe.com/legal/software-license-agreement.
** For further information use the contact form at
** https://www.mikroe.com/contact.
**
**
** GNU Lesser General Public License Usage
**
** Alternatively, this file may be used for
** non-commercial projects under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** The above copyright notice and this permission notice shall be
** included in all copies or substantial portions of the Software.
**
** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
** OF MERCHANTABILITY, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
** TO THE WARRANTIES FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
** DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
** OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
**
****************************************************************************/
/*!
* @file  mcu_reg_addresses.h
* @brief MCU specific register address definitions.
* @details MK60DN256VLQ10 register address definitions.
*/

#ifndef _MCU_REG_ADDRESSES_H_
#define _MCU_REG_ADDRESSES_H_

// MK60DN256VLQ10 REGISTER DEFINITIONS
#define SIM_SCGC6_REG_ADDRESS (0x4004803CUL) 
#define RTC_TSR_REG_ADDRESS (0x4003D000UL) 
#define RTC_CR_REG_ADDRESS (0x4003D010UL) 
#define RTC_SR_REG_ADDRESS (0x4003D014UL) 
#define RTC_IER_REG_ADDRESS (0x4003D01CUL) 
#define RTC_TAR_REG_ADDRESS (0x4003D008UL) 
#define WDOG_REFRESH_REG_ADDRESS (0x4005200CUL) 
#define WDOG_STCTRLH_REG_ADDRESS (0x40052000UL) 
#define WDOG_UNLOCK_REG_ADDRESS (0x4005200EUL) 
#define WDOG_TOVALH_REG_ADDRESS (0x40052004UL) 
#define WDOG_TOVALL_REG_ADDRESS (0x40052006UL)
// EOF REGISTER DEFINITIONS

#endif // _MCU_REG_ADDRESSES_H_
// ------------------------------------------------------------------------- END
