/****************************************************************************
**
** Copyright (C) 2024 MikroElektronika d.o.o.
** Contact: https://www.mikroe.com/contact
**
** This file is part of the mikroSDK package
**
** Commercial License Usage
**
** Licensees holding valid commercial NECTO compilers AI licenses may use this
** file in accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The MikroElektronika Company.
** For licensing terms and conditions see
** https://www.mikroe.com/legal/software-license-agreement.
** For further information use the contact form at
** https://www.mikroe.com/contact.
**
**
** GNU Lesser General Public License Usage
**
** Alternatively, this file may be used for
** non-commercial projects under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** The above copyright notice and this permission notice shall be
** included in all copies or substantial portions of the Software.
**
** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
** OF MERCHANTABILITY, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
** TO THE WARRANTIES FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
** DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
** OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
**
****************************************************************************/
/*!
* @file  mcu_definitions.h
* @brief PIC24EP512GU810 MCU specific pin and module definitions.
*/

#ifndef _MCU_DEFINITIONS_H_
#define _MCU_DEFINITIONS_H_

#include "mcu_reg_addresses.h"
#include "can_definitions.h"

// ADC
#define ADC1_RA6 (6)
#define ADC1_RA6_AN22 (22)
#define ADC1_RA7 (7)
#define ADC1_RA7_AN23 (23)
#define ADC1_RB0 (0)
#define ADC1_RB0_AN0 (0)
#define ADC1_RB1 (1)
#define ADC1_RB1_AN1 (1)
#define ADC1_RB10 (10)
#define ADC1_RB10_AN10 (10)
#define ADC1_RB11 (11)
#define ADC1_RB11_AN11 (11)
#define ADC1_RB12 (12)
#define ADC1_RB12_AN12 (12)
#define ADC1_RB13 (13)
#define ADC1_RB13_AN13 (13)
#define ADC1_RB14 (14)
#define ADC1_RB14_AN14 (14)
#define ADC1_RB15 (15)
#define ADC1_RB15_AN15 (15)
#define ADC1_RB2 (2)
#define ADC1_RB2_AN2 (2)
#define ADC1_RB3 (3)
#define ADC1_RB3_AN3 (3)
#define ADC1_RB4 (4)
#define ADC1_RB4_AN4 (4)
#define ADC1_RB5 (5)
#define ADC1_RB5_AN5 (5)
#define ADC1_RB6 (6)
#define ADC1_RB6_AN6 (6)
#define ADC1_RB7 (7)
#define ADC1_RB7_AN7 (7)
#define ADC1_RB8 (8)
#define ADC1_RB8_AN8 (8)
#define ADC1_RB9 (9)
#define ADC1_RB9_AN9 (9)
#define ADC1_RC1 (1)
#define ADC1_RC1_AN16 (16)
#define ADC1_RC2 (2)
#define ADC1_RC2_AN17 (17)
#define ADC1_RC3 (3)
#define ADC1_RC3_AN18 (18)
#define ADC1_RC4 (4)
#define ADC1_RC4_AN19 (19)
#define ADC1_RE0 (0)
#define ADC1_RE0_AN24 (24)
#define ADC1_RE1 (1)
#define ADC1_RE1_AN25 (25)
#define ADC1_RE2 (2)
#define ADC1_RE2_AN26 (26)
#define ADC1_RE3 (3)
#define ADC1_RE3_AN27 (27)
#define ADC1_RE4 (4)
#define ADC1_RE4_AN28 (28)
#define ADC1_RE5 (5)
#define ADC1_RE5_AN29 (29)
#define ADC1_RE6 (6)
#define ADC1_RE6_AN30 (30)
#define ADC1_RE7 (7)
#define ADC1_RE7_AN31 (31)
#define ADC1_RE8 (8)
#define ADC1_RE8_AN20 (20)
#define ADC1_RE9 (9)
#define ADC1_RE9_AN21 (21)
#define ADC2_RB0 (0)
#define ADC2_RB0_AN0 (0)
#define ADC2_RB1 (1)
#define ADC2_RB1_AN1 (1)
#define ADC2_RB10 (10)
#define ADC2_RB10_AN10 (10)
#define ADC2_RB11 (11)
#define ADC2_RB11_AN11 (11)
#define ADC2_RB12 (12)
#define ADC2_RB12_AN12 (12)
#define ADC2_RB13 (13)
#define ADC2_RB13_AN13 (13)
#define ADC2_RB14 (14)
#define ADC2_RB14_AN14 (14)
#define ADC2_RB15 (15)
#define ADC2_RB15_AN15 (15)
#define ADC2_RB2 (2)
#define ADC2_RB2_AN2 (2)
#define ADC2_RB3 (3)
#define ADC2_RB3_AN3 (3)
#define ADC2_RB4 (4)
#define ADC2_RB4_AN4 (4)
#define ADC2_RB5 (5)
#define ADC2_RB5_AN5 (5)
#define ADC2_RB6 (6)
#define ADC2_RB6_AN6 (6)
#define ADC2_RB7 (7)
#define ADC2_RB7_AN7 (7)
#define ADC2_RB8 (8)
#define ADC2_RB8_AN8 (8)
#define ADC2_RB9 (9)
#define ADC2_RB9_AN9 (9)
// Rest of ANSELx/ANSx bits
#define HAL_LL_ANSELA_ANSA9 (9)
#define HAL_LL_ANSELA_ANSA10 (10)
#define HAL_LL_ANSELC_ANSC13 (13)
#define HAL_LL_ANSELC_ANSC14 (14)
#define HAL_LL_ANSELD_ANSD6 (6)
#define HAL_LL_ANSELD_ANSD7 (7)
#define HAL_LL_ANSELG_ANSG6 (6)
#define HAL_LL_ANSELG_ANSG7 (7)
#define HAL_LL_ANSELG_ANSG8 (8)
#define HAL_LL_ANSELG_ANSG9 (9)
// EOF Rest of ANSELx/ANSx bits


#define ADC_MODULE_1 1
#define ADC_MODULE_2 2
#define ADC_MODULE_COUNT 2
#define HAL_LL_AN_COUNT 48

#define SUPPORTED_ADC_RES_10_BIT
#define SUPPORTED_ADC_RES_12_BIT

// ADC Register addresses and offsets
#define HAL_LL_ADC1BUF0_REG_ADDRESS (0x300)
#define HAL_LL_ADC1BUF1_REG_ADDRESS (0x302)
#define HAL_LL_ADC1BUF2_REG_ADDRESS (0x304)
#define HAL_LL_ADC1BUF3_REG_ADDRESS (0x306)
#define HAL_LL_ADC1BUF4_REG_ADDRESS (0x308)
#define HAL_LL_ADC1BUF5_REG_ADDRESS (0x30A)
#define HAL_LL_ADC1BUF6_REG_ADDRESS (0x30C)
#define HAL_LL_ADC1BUF7_REG_ADDRESS (0x30E)
#define HAL_LL_ADC1BUF8_REG_ADDRESS (0x310)
#define HAL_LL_ADC1BUF9_REG_ADDRESS (0x312)
#define HAL_LL_ADC1BUFA_REG_ADDRESS (0x314)
#define HAL_LL_ADC1BUFB_REG_ADDRESS (0x316)
#define HAL_LL_ADC1BUFC_REG_ADDRESS (0x318)
#define HAL_LL_ADC1BUFD_REG_ADDRESS (0x31A)
#define HAL_LL_ADC1BUFE_REG_ADDRESS (0x31C)
#define HAL_LL_ADC1BUFF_REG_ADDRESS (0x31E)
#define HAL_LL_AD1CON1_REG_ADDRESS (0x320)
#define HAL_LL_AD1CON2_REG_ADDRESS (0x322)
#define HAL_LL_AD1CON3_REG_ADDRESS (0x324)
#define HAL_LL_AD1CHS123_REG_ADDRESS (0x326)
#define HAL_LL_AD1CHS0_REG_ADDRESS (0x328)
#define HAL_LL_AD1CSSH_REG_ADDRESS (0x32E)
#define HAL_LL_AD1CSSL_REG_ADDRESS (0x330)
#define HAL_LL_AD1CON4_REG_ADDRESS (0x332)
#define HAL_LL_ADC2BUF0_REG_ADDRESS (0x340)
#define HAL_LL_ADC2BUF1_REG_ADDRESS (0x342)
#define HAL_LL_ADC2BUF2_REG_ADDRESS (0x344)
#define HAL_LL_ADC2BUF3_REG_ADDRESS (0x346)
#define HAL_LL_ADC2BUF4_REG_ADDRESS (0x348)
#define HAL_LL_ADC2BUF5_REG_ADDRESS (0x34A)
#define HAL_LL_ADC2BUF6_REG_ADDRESS (0x34C)
#define HAL_LL_ADC2BUF7_REG_ADDRESS (0x34E)
#define HAL_LL_ADC2BUF8_REG_ADDRESS (0x350)
#define HAL_LL_ADC2BUF9_REG_ADDRESS (0x352)
#define HAL_LL_ADC2BUFA_REG_ADDRESS (0x354)
#define HAL_LL_ADC2BUFB_REG_ADDRESS (0x356)
#define HAL_LL_ADC2BUFC_REG_ADDRESS (0x358)
#define HAL_LL_ADC2BUFD_REG_ADDRESS (0x35A)
#define HAL_LL_ADC2BUFE_REG_ADDRESS (0x35C)
#define HAL_LL_ADC2BUFF_REG_ADDRESS (0x35E)
#define HAL_LL_AD2CON1_REG_ADDRESS (0x360)
#define HAL_LL_AD2CON2_REG_ADDRESS (0x362)
#define HAL_LL_AD2CON3_REG_ADDRESS (0x364)
#define HAL_LL_AD2CHS123_REG_ADDRESS (0x366)
#define HAL_LL_AD2CHS0_REG_ADDRESS (0x368)
#define HAL_LL_AD2CSSL_REG_ADDRESS (0x370)
#define HAL_LL_AD2CON4_REG_ADDRESS (0x372)
#define HAL_LL_IFS0_REG_ADDRESS (0x800)
#define HAL_LL_IFS1_REG_ADDRESS (0x802)
#define HAL_LL_IFS2_REG_ADDRESS (0x804)
#define HAL_LL_IFS3_REG_ADDRESS (0x806)
#define HAL_LL_IFS4_REG_ADDRESS (0x808)
#define HAL_LL_IFS5_REG_ADDRESS (0x80A)
#define HAL_LL_IFS7_REG_ADDRESS (0x80E)
#define HAL_LL_IFS8_REG_ADDRESS (0x810)
#define HAL_LL_IEC0_REG_ADDRESS (0x820)
#define HAL_LL_IEC1_REG_ADDRESS (0x822)
#define HAL_LL_IEC2_REG_ADDRESS (0x824)
#define HAL_LL_IEC3_REG_ADDRESS (0x826)
#define HAL_LL_IEC4_REG_ADDRESS (0x828)
#define HAL_LL_IEC5_REG_ADDRESS (0x82A)
#define HAL_LL_IEC7_REG_ADDRESS (0x82E)
#define HAL_LL_IEC8_REG_ADDRESS (0x830)
#define HAL_LL_IPC0_REG_ADDRESS (0x840)
#define HAL_LL_IPC1_REG_ADDRESS (0x842)
#define HAL_LL_IPC2_REG_ADDRESS (0x844)
#define HAL_LL_IPC3_REG_ADDRESS (0x846)
#define HAL_LL_IPC4_REG_ADDRESS (0x848)
#define HAL_LL_IPC5_REG_ADDRESS (0x84A)
#define HAL_LL_IPC6_REG_ADDRESS (0x84C)
#define HAL_LL_IPC7_REG_ADDRESS (0x84E)
#define HAL_LL_IPC8_REG_ADDRESS (0x850)
#define HAL_LL_IPC9_REG_ADDRESS (0x852)
#define HAL_LL_IPC10_REG_ADDRESS (0x854)
#define HAL_LL_IPC11_REG_ADDRESS (0x856)
#define HAL_LL_IPC12_REG_ADDRESS (0x858)
#define HAL_LL_IPC13_REG_ADDRESS (0x85A)
#define HAL_LL_IPC14_REG_ADDRESS (0x85C)
#define HAL_LL_IPC15_REG_ADDRESS (0x85E)
#define HAL_LL_IPC16_REG_ADDRESS (0x860)
#define HAL_LL_IPC17_REG_ADDRESS (0x862)
#define HAL_LL_IPC20_REG_ADDRESS (0x868)
#define HAL_LL_IPC21_REG_ADDRESS (0x86A)
#define HAL_LL_IPC22_REG_ADDRESS (0x86C)
#define HAL_LL_IPC23_REG_ADDRESS (0x86E)
#define HAL_LL_IPC29_REG_ADDRESS (0x87A)
#define HAL_LL_IPC30_REG_ADDRESS (0x87C)
#define HAL_LL_IPC31_REG_ADDRESS (0x87E)
#define HAL_LL_IPC32_REG_ADDRESS (0x880)
#define HAL_LL_IPC33_REG_ADDRESS (0x882)
#define HAL_LL_IPC34_REG_ADDRESS (0x884)
#define HAL_LL_IPC35_REG_ADDRESS (0x886)
#define HAL_LL_ANSELA_REG_ADDRESS (0xE0E)
#define HAL_LL_ANSELB_REG_ADDRESS (0xE1E)
#define HAL_LL_ANSELC_REG_ADDRESS (0xE2E)
#define HAL_LL_ANSELD_REG_ADDRESS (0xE3E)
#define HAL_LL_ANSELE_REG_ADDRESS (0xE4E)
#define HAL_LL_ANSELG_REG_ADDRESS (0xE6E)
#define _ADC_ANSEL_
// EOF ADC Register addresses and offsets
// EOF ADC

// I2C
#define I2C1_RD10_SCL1_ALT
#define I2C1_RD9_SDA1_ALT
#define I2C2_RA2_SCL2_ALT
#define I2C2_RA3_SDA2_ALT
#define I2C2_RF4_SDA2
#define I2C2_RF5_SCL2

#define I2C_MODULE_1 1
#define I2C_MODULE_2 2
#define I2C_MODULE_COUNT 2

// I2C Register addresses and offsets
#define HAL_LL_I2C1RCV_REG_ADDRESS (0x200)
#define HAL_LL_I2C1TRN_REG_ADDRESS (0x202)
#define HAL_LL_I2C1BRG_REG_ADDRESS (0x204)
#define HAL_LL_I2C1CON_REG_ADDRESS (0x206)
#define HAL_LL_I2C1STAT_REG_ADDRESS (0x208)
#define HAL_LL_I2C2RCV_REG_ADDRESS (0x210)
#define HAL_LL_I2C2TRN_REG_ADDRESS (0x212)
#define HAL_LL_I2C2BRG_REG_ADDRESS (0x214)
#define HAL_LL_I2C2CON_REG_ADDRESS (0x216)
#define HAL_LL_I2C2STAT_REG_ADDRESS (0x218)
#define HAL_LL_PADCFG1_REG_ADDRESS (0xEFE)
#define HAL_LL_FPOR_REG_ADDRESS (0xF8000C)
// EOF I2C Register addresses and offsets
// EOF I2C

// U(S)ART
#define UART1_RX_RA0_RPI16 (16)
#define UART1_RX_RA1_RPI17 (17)
#define UART1_RX_RA14_RPI30 (30)
#define UART1_RX_RA15_RPI31 (31)
#define UART1_RX_RA2_RPI18 (18)
#define UART1_RX_RA3_RPI19 (19)
#define UART1_RX_RA4_RPI20 (20)
#define UART1_RX_RA5_RPI21 (21)
#define UART1_RX_RA6_RPI22 (22)
#define UART1_RX_RA7_RPI23 (23)
#define UART1_RX_RB0_RPI32 (32)
#define UART1_RX_RB1_RPI33 (33)
#define UART1_RX_RB10_RPI42 (42)
#define UART1_RX_RB11_RPI43 (43)
#define UART1_RX_RB12_RPI44 (44)
#define UART1_RX_RB13_RPI45 (45)
#define UART1_RX_RB14_RPI46 (46)
#define UART1_RX_RB15_RPI47 (47)
#define UART1_RX_RB2_RPI34 (34)
#define UART1_RX_RB3_RPI35 (35)
#define UART1_RX_RB4_RPI36 (36)
#define UART1_RX_RB5_RPI37 (37)
#define UART1_RX_RB6_RPI38 (38)
#define UART1_RX_RB7_RPI39 (39)
#define UART1_RX_RB8_RPI40 (40)
#define UART1_RX_RB9_RPI41 (41)
#define UART1_RX_RC1_RPI49 (49)
#define UART1_RX_RC12_RPI60 (60)
#define UART1_RX_RC13_RPI61 (61)
#define UART1_RX_RC14_RPI62 (62)
#define UART1_RX_RC2_RPI50 (50)
#define UART1_RX_RC3_RPI51 (51)
#define UART1_RX_RC4_RPI52 (52)
#define UART1_RX_RD0_RP64 (64)
#define UART1_RX_RD1_RP65 (65)
#define UART1_RX_RD10_RPI74 (74)
#define UART1_RX_RD11_RPI75 (75)
#define UART1_RX_RD12_RPI76 (76)
#define UART1_RX_RD13_RPI77 (77)
#define UART1_RX_RD14_RPI78 (78)
#define UART1_RX_RD15_RP79 (79)
#define UART1_RX_RD2_RP66 (66)
#define UART1_RX_RD3_RP67 (67)
#define UART1_RX_RD4_RP68 (68)
#define UART1_RX_RD5_RP69 (69)
#define UART1_RX_RD6_RP70 (70)
#define UART1_RX_RD7_RP71 (71)
#define UART1_RX_RD8_RPI72 (72)
#define UART1_RX_RD9_RPI73 (73)
#define UART1_RX_RE0_RP80 (80)
#define UART1_RX_RE1_RPI81 (81)
#define UART1_RX_RE2_RP82 (82)
#define UART1_RX_RE3_RPI83 (83)
#define UART1_RX_RE4_RP84 (84)
#define UART1_RX_RE5_RP85 (85)
#define UART1_RX_RE6_RPI86 (86)
#define UART1_RX_RE7_RP87 (87)
#define UART1_RX_RE8_RPI88 (88)
#define UART1_RX_RE9_RPI89 (89)
#define UART1_RX_RF0_RP96 (96)
#define UART1_RX_RF1_RP97 (97)
#define UART1_RX_RF12_RP108 (108)
#define UART1_RX_RF13_RP109 (109)
#define UART1_RX_RF2_RP98 (98)
#define UART1_RX_RF3_RP99 (99)
#define UART1_RX_RF4_RP100 (100)
#define UART1_RX_RF5_RP101 (101)
#define UART1_RX_RF8_RP104 (104)
#define UART1_RX_RG0_RP112 (112)
#define UART1_RX_RG1_RP113 (113)
#define UART1_RX_RG12_RPI124 (124)
#define UART1_RX_RG13_RP125 (125)
#define UART1_RX_RG14_RP126 (126)
#define UART1_RX_RG15_RP127 (127)
#define UART1_RX_RG6_RP118 (118)
#define UART1_RX_RG7_RPI119 (119)
#define UART1_RX_RG8_RP120 (120)
#define UART1_RX_RG9_RPI121 (121)
#define UART1_TX_RD0_RP64 (64)
#define UART1_TX_RD1_RP65 (65)
#define UART1_TX_RD15_RP79 (79)
#define UART1_TX_RD2_RP66 (66)
#define UART1_TX_RD3_RP67 (67)
#define UART1_TX_RD4_RP68 (68)
#define UART1_TX_RD5_RP69 (69)
#define UART1_TX_RD6_RP70 (70)
#define UART1_TX_RD7_RP71 (71)
#define UART1_TX_RE0_RP80 (80)
#define UART1_TX_RE2_RP82 (82)
#define UART1_TX_RE4_RP84 (84)
#define UART1_TX_RE5_RP85 (85)
#define UART1_TX_RE7_RP87 (87)
#define UART1_TX_RF0_RP96 (96)
#define UART1_TX_RF1_RP97 (97)
#define UART1_TX_RF12_RP108 (108)
#define UART1_TX_RF13_RP109 (109)
#define UART1_TX_RF2_RP98 (98)
#define UART1_TX_RF3_RP99 (99)
#define UART1_TX_RF4_RP100 (100)
#define UART1_TX_RF5_RP101 (101)
#define UART1_TX_RF8_RP104 (104)
#define UART1_TX_RG0_RP112 (112)
#define UART1_TX_RG1_RP113 (113)
#define UART1_TX_RG13_RP125 (125)
#define UART1_TX_RG14_RP126 (126)
#define UART1_TX_RG15_RP127 (127)
#define UART1_TX_RG6_RP118 (118)
#define UART1_TX_RG8_RP120 (120)
#define UART2_RX_RA0_RPI16 (16)
#define UART2_RX_RA1_RPI17 (17)
#define UART2_RX_RA14_RPI30 (30)
#define UART2_RX_RA15_RPI31 (31)
#define UART2_RX_RA2_RPI18 (18)
#define UART2_RX_RA3_RPI19 (19)
#define UART2_RX_RA4_RPI20 (20)
#define UART2_RX_RA5_RPI21 (21)
#define UART2_RX_RA6_RPI22 (22)
#define UART2_RX_RA7_RPI23 (23)
#define UART2_RX_RB0_RPI32 (32)
#define UART2_RX_RB1_RPI33 (33)
#define UART2_RX_RB10_RPI42 (42)
#define UART2_RX_RB11_RPI43 (43)
#define UART2_RX_RB12_RPI44 (44)
#define UART2_RX_RB13_RPI45 (45)
#define UART2_RX_RB14_RPI46 (46)
#define UART2_RX_RB15_RPI47 (47)
#define UART2_RX_RB2_RPI34 (34)
#define UART2_RX_RB3_RPI35 (35)
#define UART2_RX_RB4_RPI36 (36)
#define UART2_RX_RB5_RPI37 (37)
#define UART2_RX_RB6_RPI38 (38)
#define UART2_RX_RB7_RPI39 (39)
#define UART2_RX_RB8_RPI40 (40)
#define UART2_RX_RB9_RPI41 (41)
#define UART2_RX_RC1_RPI49 (49)
#define UART2_RX_RC12_RPI60 (60)
#define UART2_RX_RC13_RPI61 (61)
#define UART2_RX_RC14_RPI62 (62)
#define UART2_RX_RC2_RPI50 (50)
#define UART2_RX_RC3_RPI51 (51)
#define UART2_RX_RC4_RPI52 (52)
#define UART2_RX_RD0_RP64 (64)
#define UART2_RX_RD1_RP65 (65)
#define UART2_RX_RD10_RPI74 (74)
#define UART2_RX_RD11_RPI75 (75)
#define UART2_RX_RD12_RPI76 (76)
#define UART2_RX_RD13_RPI77 (77)
#define UART2_RX_RD14_RPI78 (78)
#define UART2_RX_RD15_RP79 (79)
#define UART2_RX_RD2_RP66 (66)
#define UART2_RX_RD3_RP67 (67)
#define UART2_RX_RD4_RP68 (68)
#define UART2_RX_RD5_RP69 (69)
#define UART2_RX_RD6_RP70 (70)
#define UART2_RX_RD7_RP71 (71)
#define UART2_RX_RD8_RPI72 (72)
#define UART2_RX_RD9_RPI73 (73)
#define UART2_RX_RE0_RP80 (80)
#define UART2_RX_RE1_RPI81 (81)
#define UART2_RX_RE2_RP82 (82)
#define UART2_RX_RE3_RPI83 (83)
#define UART2_RX_RE4_RP84 (84)
#define UART2_RX_RE5_RP85 (85)
#define UART2_RX_RE6_RPI86 (86)
#define UART2_RX_RE7_RP87 (87)
#define UART2_RX_RE8_RPI88 (88)
#define UART2_RX_RE9_RPI89 (89)
#define UART2_RX_RF0_RP96 (96)
#define UART2_RX_RF1_RP97 (97)
#define UART2_RX_RF12_RP108 (108)
#define UART2_RX_RF13_RP109 (109)
#define UART2_RX_RF2_RP98 (98)
#define UART2_RX_RF3_RP99 (99)
#define UART2_RX_RF4_RP100 (100)
#define UART2_RX_RF5_RP101 (101)
#define UART2_RX_RF8_RP104 (104)
#define UART2_RX_RG0_RP112 (112)
#define UART2_RX_RG1_RP113 (113)
#define UART2_RX_RG12_RPI124 (124)
#define UART2_RX_RG13_RP125 (125)
#define UART2_RX_RG14_RP126 (126)
#define UART2_RX_RG15_RP127 (127)
#define UART2_RX_RG6_RP118 (118)
#define UART2_RX_RG7_RPI119 (119)
#define UART2_RX_RG8_RP120 (120)
#define UART2_RX_RG9_RPI121 (121)
#define UART2_TX_RD0_RP64 (64)
#define UART2_TX_RD1_RP65 (65)
#define UART2_TX_RD15_RP79 (79)
#define UART2_TX_RD2_RP66 (66)
#define UART2_TX_RD3_RP67 (67)
#define UART2_TX_RD4_RP68 (68)
#define UART2_TX_RD5_RP69 (69)
#define UART2_TX_RD6_RP70 (70)
#define UART2_TX_RD7_RP71 (71)
#define UART2_TX_RE0_RP80 (80)
#define UART2_TX_RE2_RP82 (82)
#define UART2_TX_RE4_RP84 (84)
#define UART2_TX_RE5_RP85 (85)
#define UART2_TX_RE7_RP87 (87)
#define UART2_TX_RF0_RP96 (96)
#define UART2_TX_RF1_RP97 (97)
#define UART2_TX_RF12_RP108 (108)
#define UART2_TX_RF13_RP109 (109)
#define UART2_TX_RF2_RP98 (98)
#define UART2_TX_RF3_RP99 (99)
#define UART2_TX_RF4_RP100 (100)
#define UART2_TX_RF5_RP101 (101)
#define UART2_TX_RF8_RP104 (104)
#define UART2_TX_RG0_RP112 (112)
#define UART2_TX_RG1_RP113 (113)
#define UART2_TX_RG13_RP125 (125)
#define UART2_TX_RG14_RP126 (126)
#define UART2_TX_RG15_RP127 (127)
#define UART2_TX_RG6_RP118 (118)
#define UART2_TX_RG8_RP120 (120)
#define UART3_RX_RA0_RPI16 (16)
#define UART3_RX_RA1_RPI17 (17)
#define UART3_RX_RA14_RPI30 (30)
#define UART3_RX_RA15_RPI31 (31)
#define UART3_RX_RA2_RPI18 (18)
#define UART3_RX_RA3_RPI19 (19)
#define UART3_RX_RA4_RPI20 (20)
#define UART3_RX_RA5_RPI21 (21)
#define UART3_RX_RA6_RPI22 (22)
#define UART3_RX_RA7_RPI23 (23)
#define UART3_RX_RB0_RPI32 (32)
#define UART3_RX_RB1_RPI33 (33)
#define UART3_RX_RB10_RPI42 (42)
#define UART3_RX_RB11_RPI43 (43)
#define UART3_RX_RB12_RPI44 (44)
#define UART3_RX_RB13_RPI45 (45)
#define UART3_RX_RB14_RPI46 (46)
#define UART3_RX_RB15_RPI47 (47)
#define UART3_RX_RB2_RPI34 (34)
#define UART3_RX_RB3_RPI35 (35)
#define UART3_RX_RB4_RPI36 (36)
#define UART3_RX_RB5_RPI37 (37)
#define UART3_RX_RB6_RPI38 (38)
#define UART3_RX_RB7_RPI39 (39)
#define UART3_RX_RB8_RPI40 (40)
#define UART3_RX_RB9_RPI41 (41)
#define UART3_RX_RC1_RPI49 (49)
#define UART3_RX_RC12_RPI60 (60)
#define UART3_RX_RC13_RPI61 (61)
#define UART3_RX_RC14_RPI62 (62)
#define UART3_RX_RC2_RPI50 (50)
#define UART3_RX_RC3_RPI51 (51)
#define UART3_RX_RC4_RPI52 (52)
#define UART3_RX_RD0_RP64 (64)
#define UART3_RX_RD1_RP65 (65)
#define UART3_RX_RD10_RPI74 (74)
#define UART3_RX_RD11_RPI75 (75)
#define UART3_RX_RD12_RPI76 (76)
#define UART3_RX_RD13_RPI77 (77)
#define UART3_RX_RD14_RPI78 (78)
#define UART3_RX_RD15_RP79 (79)
#define UART3_RX_RD2_RP66 (66)
#define UART3_RX_RD3_RP67 (67)
#define UART3_RX_RD4_RP68 (68)
#define UART3_RX_RD5_RP69 (69)
#define UART3_RX_RD6_RP70 (70)
#define UART3_RX_RD7_RP71 (71)
#define UART3_RX_RD8_RPI72 (72)
#define UART3_RX_RD9_RPI73 (73)
#define UART3_RX_RE0_RP80 (80)
#define UART3_RX_RE1_RPI81 (81)
#define UART3_RX_RE2_RP82 (82)
#define UART3_RX_RE3_RPI83 (83)
#define UART3_RX_RE4_RP84 (84)
#define UART3_RX_RE5_RP85 (85)
#define UART3_RX_RE6_RPI86 (86)
#define UART3_RX_RE7_RP87 (87)
#define UART3_RX_RE8_RPI88 (88)
#define UART3_RX_RE9_RPI89 (89)
#define UART3_RX_RF0_RP96 (96)
#define UART3_RX_RF1_RP97 (97)
#define UART3_RX_RF12_RP108 (108)
#define UART3_RX_RF13_RP109 (109)
#define UART3_RX_RF2_RP98 (98)
#define UART3_RX_RF3_RP99 (99)
#define UART3_RX_RF4_RP100 (100)
#define UART3_RX_RF5_RP101 (101)
#define UART3_RX_RF8_RP104 (104)
#define UART3_RX_RG0_RP112 (112)
#define UART3_RX_RG1_RP113 (113)
#define UART3_RX_RG12_RPI124 (124)
#define UART3_RX_RG13_RP125 (125)
#define UART3_RX_RG14_RP126 (126)
#define UART3_RX_RG15_RP127 (127)
#define UART3_RX_RG6_RP118 (118)
#define UART3_RX_RG7_RPI119 (119)
#define UART3_RX_RG8_RP120 (120)
#define UART3_RX_RG9_RPI121 (121)
#define UART3_TX_RD0_RP64 (64)
#define UART3_TX_RD1_RP65 (65)
#define UART3_TX_RD15_RP79 (79)
#define UART3_TX_RD2_RP66 (66)
#define UART3_TX_RD3_RP67 (67)
#define UART3_TX_RD4_RP68 (68)
#define UART3_TX_RD5_RP69 (69)
#define UART3_TX_RD6_RP70 (70)
#define UART3_TX_RD7_RP71 (71)
#define UART3_TX_RE0_RP80 (80)
#define UART3_TX_RE2_RP82 (82)
#define UART3_TX_RE4_RP84 (84)
#define UART3_TX_RE5_RP85 (85)
#define UART3_TX_RE7_RP87 (87)
#define UART3_TX_RF0_RP96 (96)
#define UART3_TX_RF1_RP97 (97)
#define UART3_TX_RF12_RP108 (108)
#define UART3_TX_RF13_RP109 (109)
#define UART3_TX_RF2_RP98 (98)
#define UART3_TX_RF3_RP99 (99)
#define UART3_TX_RF4_RP100 (100)
#define UART3_TX_RF5_RP101 (101)
#define UART3_TX_RF8_RP104 (104)
#define UART3_TX_RG0_RP112 (112)
#define UART3_TX_RG1_RP113 (113)
#define UART3_TX_RG13_RP125 (125)
#define UART3_TX_RG14_RP126 (126)
#define UART3_TX_RG15_RP127 (127)
#define UART3_TX_RG6_RP118 (118)
#define UART3_TX_RG8_RP120 (120)
#define UART4_RX_RA0_RPI16 (16)
#define UART4_RX_RA1_RPI17 (17)
#define UART4_RX_RA14_RPI30 (30)
#define UART4_RX_RA15_RPI31 (31)
#define UART4_RX_RA2_RPI18 (18)
#define UART4_RX_RA3_RPI19 (19)
#define UART4_RX_RA4_RPI20 (20)
#define UART4_RX_RA5_RPI21 (21)
#define UART4_RX_RA6_RPI22 (22)
#define UART4_RX_RA7_RPI23 (23)
#define UART4_RX_RB0_RPI32 (32)
#define UART4_RX_RB1_RPI33 (33)
#define UART4_RX_RB10_RPI42 (42)
#define UART4_RX_RB11_RPI43 (43)
#define UART4_RX_RB12_RPI44 (44)
#define UART4_RX_RB13_RPI45 (45)
#define UART4_RX_RB14_RPI46 (46)
#define UART4_RX_RB15_RPI47 (47)
#define UART4_RX_RB2_RPI34 (34)
#define UART4_RX_RB3_RPI35 (35)
#define UART4_RX_RB4_RPI36 (36)
#define UART4_RX_RB5_RPI37 (37)
#define UART4_RX_RB6_RPI38 (38)
#define UART4_RX_RB7_RPI39 (39)
#define UART4_RX_RB8_RPI40 (40)
#define UART4_RX_RB9_RPI41 (41)
#define UART4_RX_RC1_RPI49 (49)
#define UART4_RX_RC12_RPI60 (60)
#define UART4_RX_RC13_RPI61 (61)
#define UART4_RX_RC14_RPI62 (62)
#define UART4_RX_RC2_RPI50 (50)
#define UART4_RX_RC3_RPI51 (51)
#define UART4_RX_RC4_RPI52 (52)
#define UART4_RX_RD0_RP64 (64)
#define UART4_RX_RD1_RP65 (65)
#define UART4_RX_RD10_RPI74 (74)
#define UART4_RX_RD11_RPI75 (75)
#define UART4_RX_RD12_RPI76 (76)
#define UART4_RX_RD13_RPI77 (77)
#define UART4_RX_RD14_RPI78 (78)
#define UART4_RX_RD15_RP79 (79)
#define UART4_RX_RD2_RP66 (66)
#define UART4_RX_RD3_RP67 (67)
#define UART4_RX_RD4_RP68 (68)
#define UART4_RX_RD5_RP69 (69)
#define UART4_RX_RD6_RP70 (70)
#define UART4_RX_RD7_RP71 (71)
#define UART4_RX_RD8_RPI72 (72)
#define UART4_RX_RD9_RPI73 (73)
#define UART4_RX_RE0_RP80 (80)
#define UART4_RX_RE1_RPI81 (81)
#define UART4_RX_RE2_RP82 (82)
#define UART4_RX_RE3_RPI83 (83)
#define UART4_RX_RE4_RP84 (84)
#define UART4_RX_RE5_RP85 (85)
#define UART4_RX_RE6_RPI86 (86)
#define UART4_RX_RE7_RP87 (87)
#define UART4_RX_RE8_RPI88 (88)
#define UART4_RX_RE9_RPI89 (89)
#define UART4_RX_RF0_RP96 (96)
#define UART4_RX_RF1_RP97 (97)
#define UART4_RX_RF12_RP108 (108)
#define UART4_RX_RF13_RP109 (109)
#define UART4_RX_RF2_RP98 (98)
#define UART4_RX_RF3_RP99 (99)
#define UART4_RX_RF4_RP100 (100)
#define UART4_RX_RF5_RP101 (101)
#define UART4_RX_RF8_RP104 (104)
#define UART4_RX_RG0_RP112 (112)
#define UART4_RX_RG1_RP113 (113)
#define UART4_RX_RG12_RPI124 (124)
#define UART4_RX_RG13_RP125 (125)
#define UART4_RX_RG14_RP126 (126)
#define UART4_RX_RG15_RP127 (127)
#define UART4_RX_RG6_RP118 (118)
#define UART4_RX_RG7_RPI119 (119)
#define UART4_RX_RG8_RP120 (120)
#define UART4_RX_RG9_RPI121 (121)
#define UART4_TX_RD0_RP64 (64)
#define UART4_TX_RD1_RP65 (65)
#define UART4_TX_RD15_RP79 (79)
#define UART4_TX_RD2_RP66 (66)
#define UART4_TX_RD3_RP67 (67)
#define UART4_TX_RD4_RP68 (68)
#define UART4_TX_RD5_RP69 (69)
#define UART4_TX_RD6_RP70 (70)
#define UART4_TX_RD7_RP71 (71)
#define UART4_TX_RE0_RP80 (80)
#define UART4_TX_RE2_RP82 (82)
#define UART4_TX_RE4_RP84 (84)
#define UART4_TX_RE5_RP85 (85)
#define UART4_TX_RE7_RP87 (87)
#define UART4_TX_RF0_RP96 (96)
#define UART4_TX_RF1_RP97 (97)
#define UART4_TX_RF12_RP108 (108)
#define UART4_TX_RF13_RP109 (109)
#define UART4_TX_RF2_RP98 (98)
#define UART4_TX_RF3_RP99 (99)
#define UART4_TX_RF4_RP100 (100)
#define UART4_TX_RF5_RP101 (101)
#define UART4_TX_RF8_RP104 (104)
#define UART4_TX_RG0_RP112 (112)
#define UART4_TX_RG1_RP113 (113)
#define UART4_TX_RG13_RP125 (125)
#define UART4_TX_RG14_RP126 (126)
#define UART4_TX_RG15_RP127 (127)
#define UART4_TX_RG6_RP118 (118)
#define UART4_TX_RG8_RP120 (120)

#define UART_MODULE_1 1
#define UART_MODULE_2 2
#define UART_MODULE_3 3
#define UART_MODULE_4 4
#define UART_MODULE_COUNT 4

// U(S)ART Register addresses and offsets
#define HAL_LL_U1MODE_REG_ADDRESS (0x220)
#define HAL_LL_U1STA_REG_ADDRESS (0x222)
#define HAL_LL_U1TXREG_REG_ADDRESS (0x224)
#define HAL_LL_U1RXREG_REG_ADDRESS (0x226)
#define HAL_LL_U1BRG_REG_ADDRESS (0x228)
#define HAL_LL_U2MODE_REG_ADDRESS (0x230)
#define HAL_LL_U2STA_REG_ADDRESS (0x232)
#define HAL_LL_U2TXREG_REG_ADDRESS (0x234)
#define HAL_LL_U2RXREG_REG_ADDRESS (0x236)
#define HAL_LL_U2BRG_REG_ADDRESS (0x238)
#define HAL_LL_U3MODE_REG_ADDRESS (0x250)
#define HAL_LL_U3STA_REG_ADDRESS (0x252)
#define HAL_LL_U3TXREG_REG_ADDRESS (0x254)
#define HAL_LL_U3RXREG_REG_ADDRESS (0x256)
#define HAL_LL_U3BRG_REG_ADDRESS (0x258)
#define HAL_LL_U4MODE_REG_ADDRESS (0x2B0)
#define HAL_LL_U4STA_REG_ADDRESS (0x2B2)
#define HAL_LL_U4TXREG_REG_ADDRESS (0x2B4)
#define HAL_LL_U4RXREG_REG_ADDRESS (0x2B6)
#define HAL_LL_U4BRG_REG_ADDRESS (0x2B8)
// EOF U(S)ART Register addresses and offsets
// EOF U(S)ART

// SPI
#define SPI1_MISO_RA0_RPI16 (16)
#define SPI1_MISO_RA1_RPI17 (17)
#define SPI1_MISO_RA14_RPI30 (30)
#define SPI1_MISO_RA15_RPI31 (31)
#define SPI1_MISO_RA2_RPI18 (18)
#define SPI1_MISO_RA3_RPI19 (19)
#define SPI1_MISO_RA4_RPI20 (20)
#define SPI1_MISO_RA5_RPI21 (21)
#define SPI1_MISO_RA6_RPI22 (22)
#define SPI1_MISO_RA7_RPI23 (23)
#define SPI1_MISO_RB0_RPI32 (32)
#define SPI1_MISO_RB1_RPI33 (33)
#define SPI1_MISO_RB10_RPI42 (42)
#define SPI1_MISO_RB11_RPI43 (43)
#define SPI1_MISO_RB12_RPI44 (44)
#define SPI1_MISO_RB13_RPI45 (45)
#define SPI1_MISO_RB14_RPI46 (46)
#define SPI1_MISO_RB15_RPI47 (47)
#define SPI1_MISO_RB2_RPI34 (34)
#define SPI1_MISO_RB3_RPI35 (35)
#define SPI1_MISO_RB4_RPI36 (36)
#define SPI1_MISO_RB5_RPI37 (37)
#define SPI1_MISO_RB6_RPI38 (38)
#define SPI1_MISO_RB7_RPI39 (39)
#define SPI1_MISO_RB8_RPI40 (40)
#define SPI1_MISO_RB9_RPI41 (41)
#define SPI1_MISO_RC1_RPI49 (49)
#define SPI1_MISO_RC12_RPI60 (60)
#define SPI1_MISO_RC13_RPI61 (61)
#define SPI1_MISO_RC14_RPI62 (62)
#define SPI1_MISO_RC2_RPI50 (50)
#define SPI1_MISO_RC3_RPI51 (51)
#define SPI1_MISO_RC4_RPI52 (52)
#define SPI1_MISO_RD0_RP64 (64)
#define SPI1_MISO_RD1_RP65 (65)
#define SPI1_MISO_RD10_RPI74 (74)
#define SPI1_MISO_RD11_RPI75 (75)
#define SPI1_MISO_RD12_RPI76 (76)
#define SPI1_MISO_RD13_RPI77 (77)
#define SPI1_MISO_RD14_RPI78 (78)
#define SPI1_MISO_RD15_RP79 (79)
#define SPI1_MISO_RD2_RP66 (66)
#define SPI1_MISO_RD3_RP67 (67)
#define SPI1_MISO_RD4_RP68 (68)
#define SPI1_MISO_RD5_RP69 (69)
#define SPI1_MISO_RD6_RP70 (70)
#define SPI1_MISO_RD7_RP71 (71)
#define SPI1_MISO_RD8_RPI72 (72)
#define SPI1_MISO_RD9_RPI73 (73)
#define SPI1_MISO_RE0_RP80 (80)
#define SPI1_MISO_RE1_RPI81 (81)
#define SPI1_MISO_RE2_RP82 (82)
#define SPI1_MISO_RE3_RPI83 (83)
#define SPI1_MISO_RE4_RP84 (84)
#define SPI1_MISO_RE5_RP85 (85)
#define SPI1_MISO_RE6_RPI86 (86)
#define SPI1_MISO_RE7_RP87 (87)
#define SPI1_MISO_RE8_RPI88 (88)
#define SPI1_MISO_RE9_RPI89 (89)
#define SPI1_MISO_RF0_RP96 (96)
#define SPI1_MISO_RF1_RP97 (97)
#define SPI1_MISO_RF12_RP108 (108)
#define SPI1_MISO_RF13_RP109 (109)
#define SPI1_MISO_RF2_RP98 (98)
#define SPI1_MISO_RF3_RP99 (99)
#define SPI1_MISO_RF4_RP100 (100)
#define SPI1_MISO_RF5_RP101 (101)
#define SPI1_MISO_RF8_RP104 (104)
#define SPI1_MISO_RG0_RP112 (112)
#define SPI1_MISO_RG1_RP113 (113)
#define SPI1_MISO_RG12_RPI124 (124)
#define SPI1_MISO_RG13_RP125 (125)
#define SPI1_MISO_RG14_RP126 (126)
#define SPI1_MISO_RG15_RP127 (127)
#define SPI1_MISO_RG6_RP118 (118)
#define SPI1_MISO_RG7_RPI119 (119)
#define SPI1_MISO_RG8_RP120 (120)
#define SPI1_MISO_RG9_RPI121 (121)
#define SPI1_MOSI_RD0_RP64 (64)
#define SPI1_MOSI_RD1_RP65 (65)
#define SPI1_MOSI_RD15_RP79 (79)
#define SPI1_MOSI_RD2_RP66 (66)
#define SPI1_MOSI_RD3_RP67 (67)
#define SPI1_MOSI_RD4_RP68 (68)
#define SPI1_MOSI_RD5_RP69 (69)
#define SPI1_MOSI_RD6_RP70 (70)
#define SPI1_MOSI_RD7_RP71 (71)
#define SPI1_MOSI_RE0_RP80 (80)
#define SPI1_MOSI_RE2_RP82 (82)
#define SPI1_MOSI_RE4_RP84 (84)
#define SPI1_MOSI_RE5_RP85 (85)
#define SPI1_MOSI_RE7_RP87 (87)
#define SPI1_MOSI_RF0_RP96 (96)
#define SPI1_MOSI_RF1_RP97 (97)
#define SPI1_MOSI_RF12_RP108 (108)
#define SPI1_MOSI_RF13_RP109 (109)
#define SPI1_MOSI_RF2_RP98 (98)
#define SPI1_MOSI_RF3_RP99 (99)
#define SPI1_MOSI_RF4_RP100 (100)
#define SPI1_MOSI_RF5_RP101 (101)
#define SPI1_MOSI_RF8_RP104 (104)
#define SPI1_MOSI_RG0_RP112 (112)
#define SPI1_MOSI_RG1_RP113 (113)
#define SPI1_MOSI_RG13_RP125 (125)
#define SPI1_MOSI_RG14_RP126 (126)
#define SPI1_MOSI_RG15_RP127 (127)
#define SPI1_MOSI_RG6_RP118 (118)
#define SPI1_MOSI_RG8_RP120 (120)
#define SPI1_SCK_RA0_RPI16 (16)
#define SPI1_SCK_RA1_RPI17 (17)
#define SPI1_SCK_RA14_RPI30 (30)
#define SPI1_SCK_RA15_RPI31 (31)
#define SPI1_SCK_RA2_RPI18 (18)
#define SPI1_SCK_RA3_RPI19 (19)
#define SPI1_SCK_RA4_RPI20 (20)
#define SPI1_SCK_RA5_RPI21 (21)
#define SPI1_SCK_RA6_RPI22 (22)
#define SPI1_SCK_RA7_RPI23 (23)
#define SPI1_SCK_RB0_RPI32 (32)
#define SPI1_SCK_RB1_RPI33 (33)
#define SPI1_SCK_RB10_RPI42 (42)
#define SPI1_SCK_RB11_RPI43 (43)
#define SPI1_SCK_RB12_RPI44 (44)
#define SPI1_SCK_RB13_RPI45 (45)
#define SPI1_SCK_RB14_RPI46 (46)
#define SPI1_SCK_RB15_RPI47 (47)
#define SPI1_SCK_RB2_RPI34 (34)
#define SPI1_SCK_RB3_RPI35 (35)
#define SPI1_SCK_RB4_RPI36 (36)
#define SPI1_SCK_RB5_RPI37 (37)
#define SPI1_SCK_RB6_RPI38 (38)
#define SPI1_SCK_RB7_RPI39 (39)
#define SPI1_SCK_RB8_RPI40 (40)
#define SPI1_SCK_RB9_RPI41 (41)
#define SPI1_SCK_RC1_RPI49 (49)
#define SPI1_SCK_RC12_RPI60 (60)
#define SPI1_SCK_RC13_RPI61 (61)
#define SPI1_SCK_RC14_RPI62 (62)
#define SPI1_SCK_RC2_RPI50 (50)
#define SPI1_SCK_RC3_RPI51 (51)
#define SPI1_SCK_RC4_RPI52 (52)
#define SPI1_SCK_RD0_RP64 (64)
#define SPI1_SCK_RD1_RP65 (65)
#define SPI1_SCK_RD10_RPI74 (74)
#define SPI1_SCK_RD11_RPI75 (75)
#define SPI1_SCK_RD12_RPI76 (76)
#define SPI1_SCK_RD13_RPI77 (77)
#define SPI1_SCK_RD14_RPI78 (78)
#define SPI1_SCK_RD15_RP79 (79)
#define SPI1_SCK_RD2_RP66 (66)
#define SPI1_SCK_RD3_RP67 (67)
#define SPI1_SCK_RD4_RP68 (68)
#define SPI1_SCK_RD5_RP69 (69)
#define SPI1_SCK_RD6_RP70 (70)
#define SPI1_SCK_RD7_RP71 (71)
#define SPI1_SCK_RD8_RPI72 (72)
#define SPI1_SCK_RD9_RPI73 (73)
#define SPI1_SCK_RE0_RP80 (80)
#define SPI1_SCK_RE1_RPI81 (81)
#define SPI1_SCK_RE2_RP82 (82)
#define SPI1_SCK_RE3_RPI83 (83)
#define SPI1_SCK_RE4_RP84 (84)
#define SPI1_SCK_RE5_RP85 (85)
#define SPI1_SCK_RE6_RPI86 (86)
#define SPI1_SCK_RE7_RP87 (87)
#define SPI1_SCK_RE8_RPI88 (88)
#define SPI1_SCK_RE9_RPI89 (89)
#define SPI1_SCK_RF0_RP96 (96)
#define SPI1_SCK_RF1_RP97 (97)
#define SPI1_SCK_RF12_RP108 (108)
#define SPI1_SCK_RF13_RP109 (109)
#define SPI1_SCK_RF2_RP98 (98)
#define SPI1_SCK_RF3_RP99 (99)
#define SPI1_SCK_RF4_RP100 (100)
#define SPI1_SCK_RF5_RP101 (101)
#define SPI1_SCK_RF8_RP104 (104)
#define SPI1_SCK_RG0_RP112 (112)
#define SPI1_SCK_RG1_RP113 (113)
#define SPI1_SCK_RG12_RPI124 (124)
#define SPI1_SCK_RG13_RP125 (125)
#define SPI1_SCK_RG14_RP126 (126)
#define SPI1_SCK_RG15_RP127 (127)
#define SPI1_SCK_RG6_RP118 (118)
#define SPI1_SCK_RG7_RPI119 (119)
#define SPI1_SCK_RG8_RP120 (120)
#define SPI1_SCK_RG9_RPI121 (121)
#define SPI2_MISO_RA0_RPI16 (16)
#define SPI2_MISO_RA1_RPI17 (17)
#define SPI2_MISO_RA14_RPI30 (30)
#define SPI2_MISO_RA15_RPI31 (31)
#define SPI2_MISO_RA2_RPI18 (18)
#define SPI2_MISO_RA3_RPI19 (19)
#define SPI2_MISO_RA4_RPI20 (20)
#define SPI2_MISO_RA5_RPI21 (21)
#define SPI2_MISO_RA6_RPI22 (22)
#define SPI2_MISO_RA7_RPI23 (23)
#define SPI2_MISO_RB0_RPI32 (32)
#define SPI2_MISO_RB1_RPI33 (33)
#define SPI2_MISO_RB10_RPI42 (42)
#define SPI2_MISO_RB11_RPI43 (43)
#define SPI2_MISO_RB12_RPI44 (44)
#define SPI2_MISO_RB13_RPI45 (45)
#define SPI2_MISO_RB14_RPI46 (46)
#define SPI2_MISO_RB15_RPI47 (47)
#define SPI2_MISO_RB2_RPI34 (34)
#define SPI2_MISO_RB3_RPI35 (35)
#define SPI2_MISO_RB4_RPI36 (36)
#define SPI2_MISO_RB5_RPI37 (37)
#define SPI2_MISO_RB6_RPI38 (38)
#define SPI2_MISO_RB7_RPI39 (39)
#define SPI2_MISO_RB8_RPI40 (40)
#define SPI2_MISO_RB9_RPI41 (41)
#define SPI2_MISO_RC1_RPI49 (49)
#define SPI2_MISO_RC12_RPI60 (60)
#define SPI2_MISO_RC13_RPI61 (61)
#define SPI2_MISO_RC14_RPI62 (62)
#define SPI2_MISO_RC2_RPI50 (50)
#define SPI2_MISO_RC3_RPI51 (51)
#define SPI2_MISO_RC4_RPI52 (52)
#define SPI2_MISO_RD0_RP64 (64)
#define SPI2_MISO_RD1_RP65 (65)
#define SPI2_MISO_RD10_RPI74 (74)
#define SPI2_MISO_RD11_RPI75 (75)
#define SPI2_MISO_RD12_RPI76 (76)
#define SPI2_MISO_RD13_RPI77 (77)
#define SPI2_MISO_RD14_RPI78 (78)
#define SPI2_MISO_RD15_RP79 (79)
#define SPI2_MISO_RD2_RP66 (66)
#define SPI2_MISO_RD3_RP67 (67)
#define SPI2_MISO_RD4_RP68 (68)
#define SPI2_MISO_RD5_RP69 (69)
#define SPI2_MISO_RD6_RP70 (70)
#define SPI2_MISO_RD7_RP71 (71)
#define SPI2_MISO_RD8_RPI72 (72)
#define SPI2_MISO_RD9_RPI73 (73)
#define SPI2_MISO_RE0_RP80 (80)
#define SPI2_MISO_RE1_RPI81 (81)
#define SPI2_MISO_RE2_RP82 (82)
#define SPI2_MISO_RE3_RPI83 (83)
#define SPI2_MISO_RE4_RP84 (84)
#define SPI2_MISO_RE5_RP85 (85)
#define SPI2_MISO_RE6_RPI86 (86)
#define SPI2_MISO_RE7_RP87 (87)
#define SPI2_MISO_RE8_RPI88 (88)
#define SPI2_MISO_RE9_RPI89 (89)
#define SPI2_MISO_RF0_RP96 (96)
#define SPI2_MISO_RF1_RP97 (97)
#define SPI2_MISO_RF12_RP108 (108)
#define SPI2_MISO_RF13_RP109 (109)
#define SPI2_MISO_RF2_RP98 (98)
#define SPI2_MISO_RF3_RP99 (99)
#define SPI2_MISO_RF4_RP100 (100)
#define SPI2_MISO_RF5_RP101 (101)
#define SPI2_MISO_RF8_RP104 (104)
#define SPI2_MISO_RG0_RP112 (112)
#define SPI2_MISO_RG1_RP113 (113)
#define SPI2_MISO_RG12_RPI124 (124)
#define SPI2_MISO_RG13_RP125 (125)
#define SPI2_MISO_RG14_RP126 (126)
#define SPI2_MISO_RG15_RP127 (127)
#define SPI2_MISO_RG6_RP118 (118)
#define SPI2_MISO_RG7
#define SPI2_MISO_RG7_RPI119 (119)
#define SPI2_MISO_RG8_RP120 (120)
#define SPI2_MISO_RG9_RPI121 (121)
#define SPI2_MOSI_RD0_RP64 (64)
#define SPI2_MOSI_RD1_RP65 (65)
#define SPI2_MOSI_RD15_RP79 (79)
#define SPI2_MOSI_RD2_RP66 (66)
#define SPI2_MOSI_RD3_RP67 (67)
#define SPI2_MOSI_RD4_RP68 (68)
#define SPI2_MOSI_RD5_RP69 (69)
#define SPI2_MOSI_RD6_RP70 (70)
#define SPI2_MOSI_RD7_RP71 (71)
#define SPI2_MOSI_RE0_RP80 (80)
#define SPI2_MOSI_RE2_RP82 (82)
#define SPI2_MOSI_RE4_RP84 (84)
#define SPI2_MOSI_RE5_RP85 (85)
#define SPI2_MOSI_RE7_RP87 (87)
#define SPI2_MOSI_RF0_RP96 (96)
#define SPI2_MOSI_RF1_RP97 (97)
#define SPI2_MOSI_RF12_RP108 (108)
#define SPI2_MOSI_RF13_RP109 (109)
#define SPI2_MOSI_RF2_RP98 (98)
#define SPI2_MOSI_RF3_RP99 (99)
#define SPI2_MOSI_RF4_RP100 (100)
#define SPI2_MOSI_RF5_RP101 (101)
#define SPI2_MOSI_RF8_RP104 (104)
#define SPI2_MOSI_RG0_RP112 (112)
#define SPI2_MOSI_RG1_RP113 (113)
#define SPI2_MOSI_RG13_RP125 (125)
#define SPI2_MOSI_RG14_RP126 (126)
#define SPI2_MOSI_RG15_RP127 (127)
#define SPI2_MOSI_RG6_RP118 (118)
#define SPI2_MOSI_RG8
#define SPI2_MOSI_RG8_RP120 (120)
#define SPI2_SCK_RA0_RPI16 (16)
#define SPI2_SCK_RA1_RPI17 (17)
#define SPI2_SCK_RA14_RPI30 (30)
#define SPI2_SCK_RA15_RPI31 (31)
#define SPI2_SCK_RA2_RPI18 (18)
#define SPI2_SCK_RA3_RPI19 (19)
#define SPI2_SCK_RA4_RPI20 (20)
#define SPI2_SCK_RA5_RPI21 (21)
#define SPI2_SCK_RA6_RPI22 (22)
#define SPI2_SCK_RA7_RPI23 (23)
#define SPI2_SCK_RB0_RPI32 (32)
#define SPI2_SCK_RB1_RPI33 (33)
#define SPI2_SCK_RB10_RPI42 (42)
#define SPI2_SCK_RB11_RPI43 (43)
#define SPI2_SCK_RB12_RPI44 (44)
#define SPI2_SCK_RB13_RPI45 (45)
#define SPI2_SCK_RB14_RPI46 (46)
#define SPI2_SCK_RB15_RPI47 (47)
#define SPI2_SCK_RB2_RPI34 (34)
#define SPI2_SCK_RB3_RPI35 (35)
#define SPI2_SCK_RB4_RPI36 (36)
#define SPI2_SCK_RB5_RPI37 (37)
#define SPI2_SCK_RB6_RPI38 (38)
#define SPI2_SCK_RB7_RPI39 (39)
#define SPI2_SCK_RB8_RPI40 (40)
#define SPI2_SCK_RB9_RPI41 (41)
#define SPI2_SCK_RC1_RPI49 (49)
#define SPI2_SCK_RC12_RPI60 (60)
#define SPI2_SCK_RC13_RPI61 (61)
#define SPI2_SCK_RC14_RPI62 (62)
#define SPI2_SCK_RC2_RPI50 (50)
#define SPI2_SCK_RC3_RPI51 (51)
#define SPI2_SCK_RC4_RPI52 (52)
#define SPI2_SCK_RD0_RP64 (64)
#define SPI2_SCK_RD1_RP65 (65)
#define SPI2_SCK_RD10_RPI74 (74)
#define SPI2_SCK_RD11_RPI75 (75)
#define SPI2_SCK_RD12_RPI76 (76)
#define SPI2_SCK_RD13_RPI77 (77)
#define SPI2_SCK_RD14_RPI78 (78)
#define SPI2_SCK_RD15_RP79 (79)
#define SPI2_SCK_RD2_RP66 (66)
#define SPI2_SCK_RD3_RP67 (67)
#define SPI2_SCK_RD4_RP68 (68)
#define SPI2_SCK_RD5_RP69 (69)
#define SPI2_SCK_RD6_RP70 (70)
#define SPI2_SCK_RD7_RP71 (71)
#define SPI2_SCK_RD8_RPI72 (72)
#define SPI2_SCK_RD9_RPI73 (73)
#define SPI2_SCK_RE0_RP80 (80)
#define SPI2_SCK_RE1_RPI81 (81)
#define SPI2_SCK_RE2_RP82 (82)
#define SPI2_SCK_RE3_RPI83 (83)
#define SPI2_SCK_RE4_RP84 (84)
#define SPI2_SCK_RE5_RP85 (85)
#define SPI2_SCK_RE6_RPI86 (86)
#define SPI2_SCK_RE7_RP87 (87)
#define SPI2_SCK_RE8_RPI88 (88)
#define SPI2_SCK_RE9_RPI89 (89)
#define SPI2_SCK_RF0_RP96 (96)
#define SPI2_SCK_RF1_RP97 (97)
#define SPI2_SCK_RF12_RP108 (108)
#define SPI2_SCK_RF13_RP109 (109)
#define SPI2_SCK_RF2_RP98 (98)
#define SPI2_SCK_RF3_RP99 (99)
#define SPI2_SCK_RF4_RP100 (100)
#define SPI2_SCK_RF5_RP101 (101)
#define SPI2_SCK_RF8_RP104 (104)
#define SPI2_SCK_RG0_RP112 (112)
#define SPI2_SCK_RG1_RP113 (113)
#define SPI2_SCK_RG12_RPI124 (124)
#define SPI2_SCK_RG13_RP125 (125)
#define SPI2_SCK_RG14_RP126 (126)
#define SPI2_SCK_RG15_RP127 (127)
#define SPI2_SCK_RG6
#define SPI2_SCK_RG6_RP118 (118)
#define SPI2_SCK_RG7_RPI119 (119)
#define SPI2_SCK_RG8_RP120 (120)
#define SPI2_SCK_RG9_RPI121 (121)
#define SPI3_MISO_RA0_RPI16 (16)
#define SPI3_MISO_RA1_RPI17 (17)
#define SPI3_MISO_RA14_RPI30 (30)
#define SPI3_MISO_RA15_RPI31 (31)
#define SPI3_MISO_RA2_RPI18 (18)
#define SPI3_MISO_RA3_RPI19 (19)
#define SPI3_MISO_RA4_RPI20 (20)
#define SPI3_MISO_RA5_RPI21 (21)
#define SPI3_MISO_RA6_RPI22 (22)
#define SPI3_MISO_RA7_RPI23 (23)
#define SPI3_MISO_RB0_RPI32 (32)
#define SPI3_MISO_RB1_RPI33 (33)
#define SPI3_MISO_RB10_RPI42 (42)
#define SPI3_MISO_RB11_RPI43 (43)
#define SPI3_MISO_RB12_RPI44 (44)
#define SPI3_MISO_RB13_RPI45 (45)
#define SPI3_MISO_RB14_RPI46 (46)
#define SPI3_MISO_RB15_RPI47 (47)
#define SPI3_MISO_RB2_RPI34 (34)
#define SPI3_MISO_RB3_RPI35 (35)
#define SPI3_MISO_RB4_RPI36 (36)
#define SPI3_MISO_RB5_RPI37 (37)
#define SPI3_MISO_RB6_RPI38 (38)
#define SPI3_MISO_RB7_RPI39 (39)
#define SPI3_MISO_RB8_RPI40 (40)
#define SPI3_MISO_RB9_RPI41 (41)
#define SPI3_MISO_RC1_RPI49 (49)
#define SPI3_MISO_RC12_RPI60 (60)
#define SPI3_MISO_RC13_RPI61 (61)
#define SPI3_MISO_RC14_RPI62 (62)
#define SPI3_MISO_RC2_RPI50 (50)
#define SPI3_MISO_RC3_RPI51 (51)
#define SPI3_MISO_RC4_RPI52 (52)
#define SPI3_MISO_RD0_RP64 (64)
#define SPI3_MISO_RD1_RP65 (65)
#define SPI3_MISO_RD10_RPI74 (74)
#define SPI3_MISO_RD11_RPI75 (75)
#define SPI3_MISO_RD12_RPI76 (76)
#define SPI3_MISO_RD13_RPI77 (77)
#define SPI3_MISO_RD14_RPI78 (78)
#define SPI3_MISO_RD15_RP79 (79)
#define SPI3_MISO_RD2_RP66 (66)
#define SPI3_MISO_RD3_RP67 (67)
#define SPI3_MISO_RD4_RP68 (68)
#define SPI3_MISO_RD5_RP69 (69)
#define SPI3_MISO_RD6_RP70 (70)
#define SPI3_MISO_RD7_RP71 (71)
#define SPI3_MISO_RD8_RPI72 (72)
#define SPI3_MISO_RD9_RPI73 (73)
#define SPI3_MISO_RE0_RP80 (80)
#define SPI3_MISO_RE1_RPI81 (81)
#define SPI3_MISO_RE2_RP82 (82)
#define SPI3_MISO_RE3_RPI83 (83)
#define SPI3_MISO_RE4_RP84 (84)
#define SPI3_MISO_RE5_RP85 (85)
#define SPI3_MISO_RE6_RPI86 (86)
#define SPI3_MISO_RE7_RP87 (87)
#define SPI3_MISO_RE8_RPI88 (88)
#define SPI3_MISO_RE9_RPI89 (89)
#define SPI3_MISO_RF0_RP96 (96)
#define SPI3_MISO_RF1_RP97 (97)
#define SPI3_MISO_RF12_RP108 (108)
#define SPI3_MISO_RF13_RP109 (109)
#define SPI3_MISO_RF2_RP98 (98)
#define SPI3_MISO_RF3_RP99 (99)
#define SPI3_MISO_RF4_RP100 (100)
#define SPI3_MISO_RF5_RP101 (101)
#define SPI3_MISO_RF8_RP104 (104)
#define SPI3_MISO_RG0_RP112 (112)
#define SPI3_MISO_RG1_RP113 (113)
#define SPI3_MISO_RG12_RPI124 (124)
#define SPI3_MISO_RG13_RP125 (125)
#define SPI3_MISO_RG14_RP126 (126)
#define SPI3_MISO_RG15_RP127 (127)
#define SPI3_MISO_RG6_RP118 (118)
#define SPI3_MISO_RG7_RPI119 (119)
#define SPI3_MISO_RG8_RP120 (120)
#define SPI3_MISO_RG9_RPI121 (121)
#define SPI3_MOSI_RD0_RP64 (64)
#define SPI3_MOSI_RD1_RP65 (65)
#define SPI3_MOSI_RD15_RP79 (79)
#define SPI3_MOSI_RD2_RP66 (66)
#define SPI3_MOSI_RD3_RP67 (67)
#define SPI3_MOSI_RD4_RP68 (68)
#define SPI3_MOSI_RD5_RP69 (69)
#define SPI3_MOSI_RD6_RP70 (70)
#define SPI3_MOSI_RD7_RP71 (71)
#define SPI3_MOSI_RE0_RP80 (80)
#define SPI3_MOSI_RE2_RP82 (82)
#define SPI3_MOSI_RE4_RP84 (84)
#define SPI3_MOSI_RE5_RP85 (85)
#define SPI3_MOSI_RE7_RP87 (87)
#define SPI3_MOSI_RF0_RP96 (96)
#define SPI3_MOSI_RF1_RP97 (97)
#define SPI3_MOSI_RF12_RP108 (108)
#define SPI3_MOSI_RF13_RP109 (109)
#define SPI3_MOSI_RF2_RP98 (98)
#define SPI3_MOSI_RF3_RP99 (99)
#define SPI3_MOSI_RF4_RP100 (100)
#define SPI3_MOSI_RF5_RP101 (101)
#define SPI3_MOSI_RF8_RP104 (104)
#define SPI3_MOSI_RG0_RP112 (112)
#define SPI3_MOSI_RG1_RP113 (113)
#define SPI3_MOSI_RG13_RP125 (125)
#define SPI3_MOSI_RG14_RP126 (126)
#define SPI3_MOSI_RG15_RP127 (127)
#define SPI3_MOSI_RG6_RP118 (118)
#define SPI3_MOSI_RG8_RP120 (120)
#define SPI3_SCK_RA0_RPI16 (16)
#define SPI3_SCK_RA1_RPI17 (17)
#define SPI3_SCK_RA14_RPI30 (30)
#define SPI3_SCK_RA15_RPI31 (31)
#define SPI3_SCK_RA2_RPI18 (18)
#define SPI3_SCK_RA3_RPI19 (19)
#define SPI3_SCK_RA4_RPI20 (20)
#define SPI3_SCK_RA5_RPI21 (21)
#define SPI3_SCK_RA6_RPI22 (22)
#define SPI3_SCK_RA7_RPI23 (23)
#define SPI3_SCK_RB0_RPI32 (32)
#define SPI3_SCK_RB1_RPI33 (33)
#define SPI3_SCK_RB10_RPI42 (42)
#define SPI3_SCK_RB11_RPI43 (43)
#define SPI3_SCK_RB12_RPI44 (44)
#define SPI3_SCK_RB13_RPI45 (45)
#define SPI3_SCK_RB14_RPI46 (46)
#define SPI3_SCK_RB15_RPI47 (47)
#define SPI3_SCK_RB2_RPI34 (34)
#define SPI3_SCK_RB3_RPI35 (35)
#define SPI3_SCK_RB4_RPI36 (36)
#define SPI3_SCK_RB5_RPI37 (37)
#define SPI3_SCK_RB6_RPI38 (38)
#define SPI3_SCK_RB7_RPI39 (39)
#define SPI3_SCK_RB8_RPI40 (40)
#define SPI3_SCK_RB9_RPI41 (41)
#define SPI3_SCK_RC1_RPI49 (49)
#define SPI3_SCK_RC12_RPI60 (60)
#define SPI3_SCK_RC13_RPI61 (61)
#define SPI3_SCK_RC14_RPI62 (62)
#define SPI3_SCK_RC2_RPI50 (50)
#define SPI3_SCK_RC3_RPI51 (51)
#define SPI3_SCK_RC4_RPI52 (52)
#define SPI3_SCK_RD0_RP64 (64)
#define SPI3_SCK_RD1_RP65 (65)
#define SPI3_SCK_RD10_RPI74 (74)
#define SPI3_SCK_RD11_RPI75 (75)
#define SPI3_SCK_RD12_RPI76 (76)
#define SPI3_SCK_RD13_RPI77 (77)
#define SPI3_SCK_RD14_RPI78 (78)
#define SPI3_SCK_RD15_RP79 (79)
#define SPI3_SCK_RD2_RP66 (66)
#define SPI3_SCK_RD3_RP67 (67)
#define SPI3_SCK_RD4_RP68 (68)
#define SPI3_SCK_RD5_RP69 (69)
#define SPI3_SCK_RD6_RP70 (70)
#define SPI3_SCK_RD7_RP71 (71)
#define SPI3_SCK_RD8_RPI72 (72)
#define SPI3_SCK_RD9_RPI73 (73)
#define SPI3_SCK_RE0_RP80 (80)
#define SPI3_SCK_RE1_RPI81 (81)
#define SPI3_SCK_RE2_RP82 (82)
#define SPI3_SCK_RE3_RPI83 (83)
#define SPI3_SCK_RE4_RP84 (84)
#define SPI3_SCK_RE5_RP85 (85)
#define SPI3_SCK_RE6_RPI86 (86)
#define SPI3_SCK_RE7_RP87 (87)
#define SPI3_SCK_RE8_RPI88 (88)
#define SPI3_SCK_RE9_RPI89 (89)
#define SPI3_SCK_RF0_RP96 (96)
#define SPI3_SCK_RF1_RP97 (97)
#define SPI3_SCK_RF12_RP108 (108)
#define SPI3_SCK_RF13_RP109 (109)
#define SPI3_SCK_RF2_RP98 (98)
#define SPI3_SCK_RF3_RP99 (99)
#define SPI3_SCK_RF4_RP100 (100)
#define SPI3_SCK_RF5_RP101 (101)
#define SPI3_SCK_RF8_RP104 (104)
#define SPI3_SCK_RG0_RP112 (112)
#define SPI3_SCK_RG1_RP113 (113)
#define SPI3_SCK_RG12_RPI124 (124)
#define SPI3_SCK_RG13_RP125 (125)
#define SPI3_SCK_RG14_RP126 (126)
#define SPI3_SCK_RG15_RP127 (127)
#define SPI3_SCK_RG6_RP118 (118)
#define SPI3_SCK_RG7_RPI119 (119)
#define SPI3_SCK_RG8_RP120 (120)
#define SPI3_SCK_RG9_RPI121 (121)
#define SPI4_MISO_RA0_RPI16 (16)
#define SPI4_MISO_RA1_RPI17 (17)
#define SPI4_MISO_RA14_RPI30 (30)
#define SPI4_MISO_RA15_RPI31 (31)
#define SPI4_MISO_RA2_RPI18 (18)
#define SPI4_MISO_RA3_RPI19 (19)
#define SPI4_MISO_RA4_RPI20 (20)
#define SPI4_MISO_RA5_RPI21 (21)
#define SPI4_MISO_RA6_RPI22 (22)
#define SPI4_MISO_RA7_RPI23 (23)
#define SPI4_MISO_RB0_RPI32 (32)
#define SPI4_MISO_RB1_RPI33 (33)
#define SPI4_MISO_RB10_RPI42 (42)
#define SPI4_MISO_RB11_RPI43 (43)
#define SPI4_MISO_RB12_RPI44 (44)
#define SPI4_MISO_RB13_RPI45 (45)
#define SPI4_MISO_RB14_RPI46 (46)
#define SPI4_MISO_RB15_RPI47 (47)
#define SPI4_MISO_RB2_RPI34 (34)
#define SPI4_MISO_RB3_RPI35 (35)
#define SPI4_MISO_RB4_RPI36 (36)
#define SPI4_MISO_RB5_RPI37 (37)
#define SPI4_MISO_RB6_RPI38 (38)
#define SPI4_MISO_RB7_RPI39 (39)
#define SPI4_MISO_RB8_RPI40 (40)
#define SPI4_MISO_RB9_RPI41 (41)
#define SPI4_MISO_RC1_RPI49 (49)
#define SPI4_MISO_RC12_RPI60 (60)
#define SPI4_MISO_RC13_RPI61 (61)
#define SPI4_MISO_RC14_RPI62 (62)
#define SPI4_MISO_RC2_RPI50 (50)
#define SPI4_MISO_RC3_RPI51 (51)
#define SPI4_MISO_RC4_RPI52 (52)
#define SPI4_MISO_RD0_RP64 (64)
#define SPI4_MISO_RD1_RP65 (65)
#define SPI4_MISO_RD10_RPI74 (74)
#define SPI4_MISO_RD11_RPI75 (75)
#define SPI4_MISO_RD12_RPI76 (76)
#define SPI4_MISO_RD13_RPI77 (77)
#define SPI4_MISO_RD14_RPI78 (78)
#define SPI4_MISO_RD15_RP79 (79)
#define SPI4_MISO_RD2_RP66 (66)
#define SPI4_MISO_RD3_RP67 (67)
#define SPI4_MISO_RD4_RP68 (68)
#define SPI4_MISO_RD5_RP69 (69)
#define SPI4_MISO_RD6_RP70 (70)
#define SPI4_MISO_RD7_RP71 (71)
#define SPI4_MISO_RD8_RPI72 (72)
#define SPI4_MISO_RD9_RPI73 (73)
#define SPI4_MISO_RE0_RP80 (80)
#define SPI4_MISO_RE1_RPI81 (81)
#define SPI4_MISO_RE2_RP82 (82)
#define SPI4_MISO_RE3_RPI83 (83)
#define SPI4_MISO_RE4_RP84 (84)
#define SPI4_MISO_RE5_RP85 (85)
#define SPI4_MISO_RE6_RPI86 (86)
#define SPI4_MISO_RE7_RP87 (87)
#define SPI4_MISO_RE8_RPI88 (88)
#define SPI4_MISO_RE9_RPI89 (89)
#define SPI4_MISO_RF0_RP96 (96)
#define SPI4_MISO_RF1_RP97 (97)
#define SPI4_MISO_RF12_RP108 (108)
#define SPI4_MISO_RF13_RP109 (109)
#define SPI4_MISO_RF2_RP98 (98)
#define SPI4_MISO_RF3_RP99 (99)
#define SPI4_MISO_RF4_RP100 (100)
#define SPI4_MISO_RF5_RP101 (101)
#define SPI4_MISO_RF8_RP104 (104)
#define SPI4_MISO_RG0_RP112 (112)
#define SPI4_MISO_RG1_RP113 (113)
#define SPI4_MISO_RG12_RPI124 (124)
#define SPI4_MISO_RG13_RP125 (125)
#define SPI4_MISO_RG14_RP126 (126)
#define SPI4_MISO_RG15_RP127 (127)
#define SPI4_MISO_RG6_RP118 (118)
#define SPI4_MISO_RG7_RPI119 (119)
#define SPI4_MISO_RG8_RP120 (120)
#define SPI4_MISO_RG9_RPI121 (121)
#define SPI4_MOSI_RD0_RP64 (64)
#define SPI4_MOSI_RD1_RP65 (65)
#define SPI4_MOSI_RD15_RP79 (79)
#define SPI4_MOSI_RD2_RP66 (66)
#define SPI4_MOSI_RD3_RP67 (67)
#define SPI4_MOSI_RD4_RP68 (68)
#define SPI4_MOSI_RD5_RP69 (69)
#define SPI4_MOSI_RD6_RP70 (70)
#define SPI4_MOSI_RD7_RP71 (71)
#define SPI4_MOSI_RE0_RP80 (80)
#define SPI4_MOSI_RE2_RP82 (82)
#define SPI4_MOSI_RE4_RP84 (84)
#define SPI4_MOSI_RE5_RP85 (85)
#define SPI4_MOSI_RE7_RP87 (87)
#define SPI4_MOSI_RF0_RP96 (96)
#define SPI4_MOSI_RF1_RP97 (97)
#define SPI4_MOSI_RF12_RP108 (108)
#define SPI4_MOSI_RF13_RP109 (109)
#define SPI4_MOSI_RF2_RP98 (98)
#define SPI4_MOSI_RF3_RP99 (99)
#define SPI4_MOSI_RF4_RP100 (100)
#define SPI4_MOSI_RF5_RP101 (101)
#define SPI4_MOSI_RF8_RP104 (104)
#define SPI4_MOSI_RG0_RP112 (112)
#define SPI4_MOSI_RG1_RP113 (113)
#define SPI4_MOSI_RG13_RP125 (125)
#define SPI4_MOSI_RG14_RP126 (126)
#define SPI4_MOSI_RG15_RP127 (127)
#define SPI4_MOSI_RG6_RP118 (118)
#define SPI4_MOSI_RG8_RP120 (120)
#define SPI4_SCK_RA0_RPI16 (16)
#define SPI4_SCK_RA1_RPI17 (17)
#define SPI4_SCK_RA14_RPI30 (30)
#define SPI4_SCK_RA15_RPI31 (31)
#define SPI4_SCK_RA2_RPI18 (18)
#define SPI4_SCK_RA3_RPI19 (19)
#define SPI4_SCK_RA4_RPI20 (20)
#define SPI4_SCK_RA5_RPI21 (21)
#define SPI4_SCK_RA6_RPI22 (22)
#define SPI4_SCK_RA7_RPI23 (23)
#define SPI4_SCK_RB0_RPI32 (32)
#define SPI4_SCK_RB1_RPI33 (33)
#define SPI4_SCK_RB10_RPI42 (42)
#define SPI4_SCK_RB11_RPI43 (43)
#define SPI4_SCK_RB12_RPI44 (44)
#define SPI4_SCK_RB13_RPI45 (45)
#define SPI4_SCK_RB14_RPI46 (46)
#define SPI4_SCK_RB15_RPI47 (47)
#define SPI4_SCK_RB2_RPI34 (34)
#define SPI4_SCK_RB3_RPI35 (35)
#define SPI4_SCK_RB4_RPI36 (36)
#define SPI4_SCK_RB5_RPI37 (37)
#define SPI4_SCK_RB6_RPI38 (38)
#define SPI4_SCK_RB7_RPI39 (39)
#define SPI4_SCK_RB8_RPI40 (40)
#define SPI4_SCK_RB9_RPI41 (41)
#define SPI4_SCK_RC1_RPI49 (49)
#define SPI4_SCK_RC12_RPI60 (60)
#define SPI4_SCK_RC13_RPI61 (61)
#define SPI4_SCK_RC14_RPI62 (62)
#define SPI4_SCK_RC2_RPI50 (50)
#define SPI4_SCK_RC3_RPI51 (51)
#define SPI4_SCK_RC4_RPI52 (52)
#define SPI4_SCK_RD0_RP64 (64)
#define SPI4_SCK_RD1_RP65 (65)
#define SPI4_SCK_RD10_RPI74 (74)
#define SPI4_SCK_RD11_RPI75 (75)
#define SPI4_SCK_RD12_RPI76 (76)
#define SPI4_SCK_RD13_RPI77 (77)
#define SPI4_SCK_RD14_RPI78 (78)
#define SPI4_SCK_RD15_RP79 (79)
#define SPI4_SCK_RD2_RP66 (66)
#define SPI4_SCK_RD3_RP67 (67)
#define SPI4_SCK_RD4_RP68 (68)
#define SPI4_SCK_RD5_RP69 (69)
#define SPI4_SCK_RD6_RP70 (70)
#define SPI4_SCK_RD7_RP71 (71)
#define SPI4_SCK_RD8_RPI72 (72)
#define SPI4_SCK_RD9_RPI73 (73)
#define SPI4_SCK_RE0_RP80 (80)
#define SPI4_SCK_RE1_RPI81 (81)
#define SPI4_SCK_RE2_RP82 (82)
#define SPI4_SCK_RE3_RPI83 (83)
#define SPI4_SCK_RE4_RP84 (84)
#define SPI4_SCK_RE5_RP85 (85)
#define SPI4_SCK_RE6_RPI86 (86)
#define SPI4_SCK_RE7_RP87 (87)
#define SPI4_SCK_RE8_RPI88 (88)
#define SPI4_SCK_RE9_RPI89 (89)
#define SPI4_SCK_RF0_RP96 (96)
#define SPI4_SCK_RF1_RP97 (97)
#define SPI4_SCK_RF12_RP108 (108)
#define SPI4_SCK_RF13_RP109 (109)
#define SPI4_SCK_RF2_RP98 (98)
#define SPI4_SCK_RF3_RP99 (99)
#define SPI4_SCK_RF4_RP100 (100)
#define SPI4_SCK_RF5_RP101 (101)
#define SPI4_SCK_RF8_RP104 (104)
#define SPI4_SCK_RG0_RP112 (112)
#define SPI4_SCK_RG1_RP113 (113)
#define SPI4_SCK_RG12_RPI124 (124)
#define SPI4_SCK_RG13_RP125 (125)
#define SPI4_SCK_RG14_RP126 (126)
#define SPI4_SCK_RG15_RP127 (127)
#define SPI4_SCK_RG6_RP118 (118)
#define SPI4_SCK_RG7_RPI119 (119)
#define SPI4_SCK_RG8_RP120 (120)
#define SPI4_SCK_RG9_RPI121 (121)

#define SPI_MODULE_1 1
#define SPI_MODULE_2 2
#define SPI_MODULE_3 3
#define SPI_MODULE_4 4
#define SPI_MODULE_COUNT 4

// SPI Register addresses and offsets
#define HAL_LL_SPI1STAT_REG_ADDRESS (0x240)
#define HAL_LL_SPI1CON1_REG_ADDRESS (0x242)
#define HAL_LL_SPI1_CONTROL_REG_ADDRESS HAL_LL_SPI1CON1_REG_ADDRESS
#define HAL_LL_SPI1BUF_REG_ADDRESS (0x248)
#define HAL_LL_SPI2STAT_REG_ADDRESS (0x260)
#define HAL_LL_SPI2CON1_REG_ADDRESS (0x262)
#define HAL_LL_SPI2_CONTROL_REG_ADDRESS HAL_LL_SPI2CON1_REG_ADDRESS
#define HAL_LL_SPI2BUF_REG_ADDRESS (0x268)
#define HAL_LL_SPI3STAT_REG_ADDRESS (0x2A0)
#define HAL_LL_SPI3CON1_REG_ADDRESS (0x2A2)
#define HAL_LL_SPI3_CONTROL_REG_ADDRESS HAL_LL_SPI3CON1_REG_ADDRESS
#define HAL_LL_SPI3BUF_REG_ADDRESS (0x2A8)
#define HAL_LL_SPI4STAT_REG_ADDRESS (0x2C0)
#define HAL_LL_SPI4CON1_REG_ADDRESS (0x2C2)
#define HAL_LL_SPI4_CONTROL_REG_ADDRESS HAL_LL_SPI4CON1_REG_ADDRESS
#define HAL_LL_SPI4BUF_REG_ADDRESS (0x2C8)
// EOF SPI Register addresses and offsets
// EOF SPI

// TIM
#define PWM_CCP1_OC1_RD15_RP79 (79)
#define PWM_CCP1_OC1_RD7_RP71 (71)
#define PWM_CCP1_OC11_RD4_RP68 (68)
#define PWM_CCP1_OC13_RD5_RP69 (69)
#define PWM_CCP1_OC15_RD6_RP70 (70)
#define PWM_CCP1_OC2_RD0_RP64 (64)
#define PWM_CCP1_OC5_RD1_RP65 (65)
#define PWM_CCP1_OC7_RD2_RP66 (66)
#define PWM_CCP1_OC9_RD3_RP67 (67)
#define PWM_CCP2_OC12_RE0_RP80 (80)
#define PWM_CCP2_OC16_RE2_RP82 (82)
#define PWM_CCP2_OC4_RE4_RP84 (84)
#define PWM_CCP2_OC4_RE5_RP85 (85)
#define PWM_CCP2_OC8_RE7_RP87 (87)
#define PWM_CCP3_OC10_RF4_RP100 (100)
#define PWM_CCP3_OC13_RF5_RP101 (101)
#define PWM_CCP3_OC16_RF3_RP99 (99)
#define PWM_CCP3_OC2_RF2_RP98 (98)
#define PWM_CCP3_OC3_RF8_RP104 (104)
#define PWM_CCP3_OC4_RF0_RP96 (96)
#define PWM_CCP3_OC6_RF1_RP97 (97)
#define PWM_CCP3_OC8_RF13_RP109 (109)
#define PWM_CCP3_OC9_RF12_RP108 (108)
#define PWM_CCP4_OC1_RG1_RP113 (113)
#define PWM_CCP4_OC13_RG8_RP120 (120)
#define PWM_CCP4_OC2_RG0_RP112 (112)
#define PWM_CCP4_OC3_RG14_RP126 (126)
#define PWM_CCP4_OC4_RG13_RP125 (125)
#define PWM_CCP4_OC8_RG15_RP127 (127)
#define PWM_CCP4_OC9_RG6_RP118 (118)
#define PWM_CCP5_OC1_RD5_RP69 (69)
#define PWM_CCP5_OC11_RD2_RP66 (66)
#define PWM_CCP5_OC13_RD3_RP67 (67)
#define PWM_CCP5_OC15_RD4_RP68 (68)
#define PWM_CCP5_OC3_RD6_RP70 (70)
#define PWM_CCP5_OC5_RD15_RP79 (79)
#define PWM_CCP5_OC5_RD7_RP71 (71)
#define PWM_CCP5_OC6_RD0_RP64 (64)
#define PWM_CCP5_OC9_RD1_RP65 (65)
#define PWM_CCP6_OC12_RE7_RP87 (87)
#define PWM_CCP6_OC16_RE0_RP80 (80)
#define PWM_CCP6_OC4_RE2_RP82 (82)
#define PWM_CCP6_OC8_RE4_RP84 (84)
#define PWM_CCP6_OC8_RE5_RP85 (85)
#define PWM_CCP7_OC1_RF5_RP101 (101)
#define PWM_CCP7_OC10_RF1_RP97 (97)
#define PWM_CCP7_OC12_RF13_RP109 (109)
#define PWM_CCP7_OC13_RF12_RP108 (108)
#define PWM_CCP7_OC14_RF4_RP100 (100)
#define PWM_CCP7_OC4_RF3_RP99 (99)
#define PWM_CCP7_OC6_RF2_RP98 (98)
#define PWM_CCP7_OC7_RF8_RP104 (104)
#define PWM_CCP7_OC8_RF0_RP96 (96)
#define PWM_CCP8_OC1_RG8_RP120 (120)
#define PWM_CCP8_OC12_RG15_RP127 (127)
#define PWM_CCP8_OC13_RG6_RP118 (118)
#define PWM_CCP8_OC5_RG1_RP113 (113)
#define PWM_CCP8_OC6_RG0_RP112 (112)
#define PWM_CCP8_OC7_RG14_RP126 (126)
#define PWM_CCP8_OC8_RG13_RP125 (125)
#define PWM_CCP9_OC1_RD3_RP67 (67)
#define PWM_CCP9_OC10_RD0_RP64 (64)
#define PWM_CCP9_OC13_RD1_RP65 (65)
#define PWM_CCP9_OC15_RD2_RP66 (66)
#define PWM_CCP9_OC3_RD4_RP68 (68)
#define PWM_CCP9_OC5_RD5_RP69 (69)
#define PWM_CCP9_OC7_RD6_RP70 (70)
#define PWM_CCP9_OC9_RD15_RP79 (79)
#define PWM_CCP9_OC9_RD7_RP71 (71)

#define CCP_MODULE_1 1
#define CCP_MODULE_2 2
#define CCP_MODULE_3 3
#define CCP_MODULE_4 4
#define CCP_MODULE_5 5
#define CCP_MODULE_6 6
#define CCP_MODULE_7 7
#define CCP_MODULE_8 8
#define CCP_MODULE_9 9

#define CCP_MODULE_COUNT 9
#define TIM_MODULE_COUNT CCP_MODULE_COUNT

// TIM Register addresses and offsets
#define HAL_LL_TMR1_REG_ADDRESS (0x100)
#define HAL_LL_PR1_REG_ADDRESS (0x102)
#define HAL_LL_T1CON_REG_ADDRESS (0x104)
#define HAL_LL_TMR2_REG_ADDRESS (0x106)
#define HAL_LL_TMR3_REG_ADDRESS (0x10A)
#define HAL_LL_PR2_REG_ADDRESS (0x10C)
#define HAL_LL_PR3_REG_ADDRESS (0x10E)
#define HAL_LL_T2CON_REG_ADDRESS (0x110)
#define HAL_LL_T3CON_REG_ADDRESS (0x112)
#define HAL_LL_TMR4_REG_ADDRESS (0x114)
#define HAL_LL_TMR5_REG_ADDRESS (0x118)
#define HAL_LL_PR4_REG_ADDRESS (0x11A)
#define HAL_LL_PR5_REG_ADDRESS (0x11C)
#define HAL_LL_T4CON_REG_ADDRESS (0x11E)
#define HAL_LL_T5CON_REG_ADDRESS (0x120)
#define HAL_LL_TMR6_REG_ADDRESS (0x122)
#define HAL_LL_TMR7_REG_ADDRESS (0x126)
#define HAL_LL_PR6_REG_ADDRESS (0x128)
#define HAL_LL_PR7_REG_ADDRESS (0x12A)
#define HAL_LL_T6CON_REG_ADDRESS (0x12C)
#define HAL_LL_T7CON_REG_ADDRESS (0x12E)
#define HAL_LL_TMR8_REG_ADDRESS (0x130)
#define HAL_LL_TMR9_REG_ADDRESS (0x134)
#define HAL_LL_PR8_REG_ADDRESS (0x136)
#define HAL_LL_PR9_REG_ADDRESS (0x138)
#define HAL_LL_T8CON_REG_ADDRESS (0x13A)
#define HAL_LL_T9CON_REG_ADDRESS (0x13C)
#define HAL_LL_OC1CON1_REG_ADDRESS (0x900)
#define HAL_LL_OC1CON2_REG_ADDRESS (0x902)
#define HAL_LL_OC1RS_REG_ADDRESS (0x904)
#define HAL_LL_OC1R_REG_ADDRESS (0x906)
#define HAL_LL_OC2CON1_REG_ADDRESS (0x90A)
#define HAL_LL_OC2CON2_REG_ADDRESS (0x90C)
#define HAL_LL_OC2RS_REG_ADDRESS (0x90E)
#define HAL_LL_OC2R_REG_ADDRESS (0x910)
#define HAL_LL_OC2TMR_REG_ADDRESS (0x912)
#define HAL_LL_OC3CON1_REG_ADDRESS (0x914)
#define HAL_LL_OC3CON2_REG_ADDRESS (0x916)
#define HAL_LL_OC3RS_REG_ADDRESS (0x918)
#define HAL_LL_OC3R_REG_ADDRESS (0x91A)
#define HAL_LL_OC3TMR_REG_ADDRESS (0x91C)
#define HAL_LL_OC4CON1_REG_ADDRESS (0x91E)
#define HAL_LL_OC4CON2_REG_ADDRESS (0x920)
#define HAL_LL_OC4RS_REG_ADDRESS (0x922)
#define HAL_LL_OC4R_REG_ADDRESS (0x924)
#define HAL_LL_OC4TMR_REG_ADDRESS (0x926)
#define HAL_LL_OC5CON1_REG_ADDRESS (0x928)
#define HAL_LL_OC5CON2_REG_ADDRESS (0x92A)
#define HAL_LL_OC5RS_REG_ADDRESS (0x92C)
#define HAL_LL_OC5R_REG_ADDRESS (0x92E)
#define HAL_LL_OC5TMR_REG_ADDRESS (0x930)
#define HAL_LL_OC6CON1_REG_ADDRESS (0x932)
#define HAL_LL_OC6CON2_REG_ADDRESS (0x934)
#define HAL_LL_OC6RS_REG_ADDRESS (0x936)
#define HAL_LL_OC6R_REG_ADDRESS (0x938)
#define HAL_LL_OC6TMR_REG_ADDRESS (0x93A)
#define HAL_LL_OC7CON1_REG_ADDRESS (0x93C)
#define HAL_LL_OC7CON2_REG_ADDRESS (0x93E)
#define HAL_LL_OC7RS_REG_ADDRESS (0x940)
#define HAL_LL_OC7R_REG_ADDRESS (0x942)
#define HAL_LL_OC7TMR_REG_ADDRESS (0x944)
#define HAL_LL_OC8CON1_REG_ADDRESS (0x946)
#define HAL_LL_OC8CON2_REG_ADDRESS (0x948)
#define HAL_LL_OC8RS_REG_ADDRESS (0x94A)
#define HAL_LL_OC8R_REG_ADDRESS (0x94C)
#define HAL_LL_OC8TMR_REG_ADDRESS (0x94E)
#define HAL_LL_OC9CON1_REG_ADDRESS (0x950)
#define HAL_LL_OC9CON2_REG_ADDRESS (0x952)
#define HAL_LL_OC9RS_REG_ADDRESS (0x954)
#define HAL_LL_OC9R_REG_ADDRESS (0x956)
#define HAL_LL_OC9TMR_REG_ADDRESS (0x958)
#define HAL_LL_OC10CON1_REG_ADDRESS (0x95A)
#define HAL_LL_OC10CON2_REG_ADDRESS (0x95C)
#define HAL_LL_OC10RS_REG_ADDRESS (0x95E)
#define HAL_LL_OC10R_REG_ADDRESS (0x960)
#define HAL_LL_OC10TMR_REG_ADDRESS (0x962)
#define HAL_LL_OC11CON1_REG_ADDRESS (0x964)
#define HAL_LL_OC11CON2_REG_ADDRESS (0x966)
#define HAL_LL_OC11RS_REG_ADDRESS (0x968)
#define HAL_LL_OC11R_REG_ADDRESS (0x96A)
#define HAL_LL_OC11TMR_REG_ADDRESS (0x96C)
#define HAL_LL_OC12CON1_REG_ADDRESS (0x96E)
#define HAL_LL_OC12CON2_REG_ADDRESS (0x970)
#define HAL_LL_OC12RS_REG_ADDRESS (0x972)
#define HAL_LL_OC12R_REG_ADDRESS (0x974)
#define HAL_LL_OC12TMR_REG_ADDRESS (0x976)
#define HAL_LL_OC13CON1_REG_ADDRESS (0x978)
#define HAL_LL_OC13CON2_REG_ADDRESS (0x97A)
#define HAL_LL_OC13RS_REG_ADDRESS (0x97C)
#define HAL_LL_OC13R_REG_ADDRESS (0x97E)
#define HAL_LL_OC13TMR_REG_ADDRESS (0x980)
#define HAL_LL_OC14CON1_REG_ADDRESS (0x982)
#define HAL_LL_OC14CON2_REG_ADDRESS (0x984)
#define HAL_LL_OC14RS_REG_ADDRESS (0x986)
#define HAL_LL_OC14R_REG_ADDRESS (0x988)
#define HAL_LL_OC14TMR_REG_ADDRESS (0x98A)
#define HAL_LL_OC15CON1_REG_ADDRESS (0x98C)
#define HAL_LL_OC15CON2_REG_ADDRESS (0x98E)
#define HAL_LL_OC15RS_REG_ADDRESS (0x990)
#define HAL_LL_OC15R_REG_ADDRESS (0x992)
#define HAL_LL_OC15TMR_REG_ADDRESS (0x994)
#define HAL_LL_OC16CON1_REG_ADDRESS (0x996)
#define HAL_LL_OC16CON2_REG_ADDRESS (0x998)
#define HAL_LL_OC16RS_REG_ADDRESS (0x99A)
#define HAL_LL_OC16R_REG_ADDRESS (0x99C)
#define HAL_LL_OC16TMR_REG_ADDRESS (0x99E)
// EOF TIM Register addresses and offsets
// EOF TIM

// GPIO
#define __RA0_CN
#define __RA1_CN
#define __RA10_CN
#define __RA14_CN
#define __RA15_CN
#define __RA2_CN
#define __RA3_CN
#define __RA4_CN
#define __RA5_CN
#define __RA6_CN
#define __RA7_CN
#define __RA9_CN
#define __RB0_CN
#define __RB1_CN
#define __RB10_CN
#define __RB11_CN
#define __RB12_CN
#define __RB13_CN
#define __RB14_CN
#define __RB15_CN
#define __RB2_CN
#define __RB3_CN
#define __RB4_CN
#define __RB5_CN
#define __RB6_CN
#define __RB7_CN
#define __RB8_CN
#define __RB9_CN
#define __RC1_CN
#define __RC12_CN
#define __RC13_CN
#define __RC14_CN
#define __RC15_CN
#define __RC2_CN
#define __RC3_CN
#define __RC4_CN
#define __RD0_CN
#define __RD1_CN
#define __RD10_CN
#define __RD11_CN
#define __RD12_CN
#define __RD13_CN
#define __RD14_CN
#define __RD15_CN
#define __RD2_CN
#define __RD3_CN
#define __RD4_CN
#define __RD5_CN
#define __RD6_CN
#define __RD7_CN
#define __RD8_CN
#define __RD9_CN
#define __RE0_CN
#define __RE1_CN
#define __RE2_CN
#define __RE3_CN
#define __RE4_CN
#define __RE5_CN
#define __RE6_CN
#define __RE7_CN
#define __RE8_CN
#define __RE9_CN
#define __RF0_CN
#define __RF1_CN
#define __RF12_CN
#define __RF13_CN
#define __RF2_CN
#define __RF3_CN
#define __RF4_CN
#define __RF5_CN
#define __RF8_CN
#define __RG0_CN
#define __RG1_CN
#define __RG12_CN
#define __RG13_CN
#define __RG14_CN
#define __RG15_CN
#define __RG2_CN
#define __RG3_CN
#define __RG6_CN
#define __RG7_CN
#define __RG8_CN
#define __RG9_CN

#define __PORT_A_CN
#define __PORT_B_CN
#define __PORT_C_CN
#define __PORT_D_CN
#define __PORT_E_CN
#define __PORT_F_CN
#define __PORT_G_CN

#define PORT_SIZE  (16)
#define PORT_COUNT (7)

#define TRISA_REG_ADDRESS (0xE00)
#define PORTA_REG_ADDRESS (0xE02)
#define LATA_REG_ADDRESS (0xE04)
#define TRISB_REG_ADDRESS (0xE10)
#define PORTB_REG_ADDRESS (0xE12)
#define LATB_REG_ADDRESS (0xE14)
#define TRISC_REG_ADDRESS (0xE20)
#define PORTC_REG_ADDRESS (0xE22)
#define LATC_REG_ADDRESS (0xE24)
#define TRISD_REG_ADDRESS (0xE30)
#define PORTD_REG_ADDRESS (0xE32)
#define LATD_REG_ADDRESS (0xE34)
#define TRISE_REG_ADDRESS (0xE40)
#define PORTE_REG_ADDRESS (0xE42)
#define LATE_REG_ADDRESS (0xE44)
#define TRISF_REG_ADDRESS (0xE50)
#define PORTF_REG_ADDRESS (0xE52)
#define LATF_REG_ADDRESS (0xE54)
#define TRISG_REG_ADDRESS (0xE60)
#define PORTG_REG_ADDRESS (0xE62)
#define LATG_REG_ADDRESS (0xE64)
// EOF GPIO

// PPS
#define HAL_LL_OSCCON_REG_ADDRESS 0x742
#define HAL_LL_UART_PPS_ENABLED true
#define HAL_LL_SPI_PPS_ENABLED true
#define HAL_LL_PWM_PPS_ENABLED true
// PPS Register addresses and offsets
#define HAL_LL_RPOR0_REG_ADDRESS (0x680)
#define HAL_LL_RPOR1_REG_ADDRESS (0x682)
#define HAL_LL_RPOR2_REG_ADDRESS (0x684)
#define HAL_LL_RPOR3_REG_ADDRESS (0x686)
#define HAL_LL_RPOR4_REG_ADDRESS (0x688)
#define HAL_LL_RPOR5_REG_ADDRESS (0x68A)
#define HAL_LL_RPOR6_REG_ADDRESS (0x68C)
#define HAL_LL_RPOR7_REG_ADDRESS (0x68E)
#define HAL_LL_RPOR8_REG_ADDRESS (0x690)
#define HAL_LL_RPOR9_REG_ADDRESS (0x692)
#define HAL_LL_RPOR11_REG_ADDRESS (0x696)
#define HAL_LL_RPOR12_REG_ADDRESS (0x698)
#define HAL_LL_RPOR13_REG_ADDRESS (0x69A)
#define HAL_LL_RPOR14_REG_ADDRESS (0x69C)
#define HAL_LL_RPOR15_REG_ADDRESS (0x69E)
#define HAL_LL_RPINR0_REG_ADDRESS (0x6A0)
#define HAL_LL_RPINR1_REG_ADDRESS (0x6A2)
#define HAL_LL_RPINR2_REG_ADDRESS (0x6A4)
#define HAL_LL_RPINR3_REG_ADDRESS (0x6A6)
#define HAL_LL_RPINR4_REG_ADDRESS (0x6A8)
#define HAL_LL_RPINR5_REG_ADDRESS (0x6AA)
#define HAL_LL_RPINR6_REG_ADDRESS (0x6AC)
#define HAL_LL_RPINR7_REG_ADDRESS (0x6AE)
#define HAL_LL_RPINR8_REG_ADDRESS (0x6B0)
#define HAL_LL_RPINR9_REG_ADDRESS (0x6B2)
#define HAL_LL_RPINR10_REG_ADDRESS (0x6B4)
#define HAL_LL_RPINR11_REG_ADDRESS (0x6B6)
#define HAL_LL_RPINR12_REG_ADDRESS (0x6B8)
#define HAL_LL_RPINR13_REG_ADDRESS (0x6BA)
#define HAL_LL_RPINR14_REG_ADDRESS (0x6BC)
#define HAL_LL_RPINR15_REG_ADDRESS (0x6BE)
#define HAL_LL_RPINR16_REG_ADDRESS (0x6C0)
#define HAL_LL_RPINR17_REG_ADDRESS (0x6C2)
#define HAL_LL_RPINR18_REG_ADDRESS (0x6C4)
#define HAL_LL_RPINR19_REG_ADDRESS (0x6C6)
#define HAL_LL_RPINR20_REG_ADDRESS (0x6C8)
#define HAL_LL_RPINR21_REG_ADDRESS (0x6CA)
#define HAL_LL_RPINR23_REG_ADDRESS (0x6CE)
#define HAL_LL_RPINR24_REG_ADDRESS (0x6D0)
#define HAL_LL_RPINR25_REG_ADDRESS (0x6D2)
#define HAL_LL_RPINR26_REG_ADDRESS (0x6D4)
#define HAL_LL_RPINR27_REG_ADDRESS (0x6D6)
#define HAL_LL_RPINR28_REG_ADDRESS (0x6D8)
#define HAL_LL_RPINR29_REG_ADDRESS (0x6DA)
#define HAL_LL_RPINR30_REG_ADDRESS (0x6DC)
#define HAL_LL_RPINR31_REG_ADDRESS (0x6DE)
#define HAL_LL_RPINR32_REG_ADDRESS (0x6E0)
#define HAL_LL_RPINR33_REG_ADDRESS (0x6E2)
#define HAL_LL_RPINR34_REG_ADDRESS (0x6E4)
#define HAL_LL_RPINR35_REG_ADDRESS (0x6E6)
#define HAL_LL_RPINR36_REG_ADDRESS (0x6E8)
#define HAL_LL_RPINR37_REG_ADDRESS (0x6EA)
#define HAL_LL_RPINR38_REG_ADDRESS (0x6EC)
#define HAL_LL_RPINR40_REG_ADDRESS (0x6F0)
#define HAL_LL_RPINR41_REG_ADDRESS (0x6F2)
#define HAL_LL_RPINR42_REG_ADDRESS (0x6F4)
#define HAL_LL_RPINR43_REG_ADDRESS (0x6F6)
#define HAL_LL_RPINR45_REG_ADDRESS (0x6FA)
// EOF PPS Register addresses and offsets
// EOF PPS

// IVT
#define USART1_RX_IVT_ADDRESS (0x002A)
#define USART1_TX_IVT_ADDRESS (0x002C)
#define USART2_RX_IVT_ADDRESS (0x0050)
#define USART2_TX_IVT_ADDRESS (0x0052)
#define USART3_RX_IVT_ADDRESS (0x00B8)
#define USART3_TX_IVT_ADDRESS (0x00BA)
#define USART4_RX_IVT_ADDRESS (0x00C4)
#define USART4_TX_IVT_ADDRESS (0x00C6)
// EOF IVT

#define _HAS_GIE_BIT_

#endif // _MCU_DEFINITIONS_H_
// ------------------------------------------------------------------------- END
