/****************************************************************************
**
** Copyright (C) 2024 MikroElektronika d.o.o.
** Contact: https://www.mikroe.com/contact
**
** This file is part of the mikroSDK package
**
** Commercial License Usage
**
** Licensees holding valid commercial NECTO compilers AI licenses may use this
** file in accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The MikroElektronika Company.
** For licensing terms and conditions see
** https://www.mikroe.com/legal/software-license-agreement.
** For further information use the contact form at
** https://www.mikroe.com/contact.
**
**
** GNU Lesser General Public License Usage
**
** Alternatively, this file may be used for
** non-commercial projects under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** The above copyright notice and this permission notice shall be
** included in all copies or substantial portions of the Software.
**
** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
** OF MERCHANTABILITY, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
** TO THE WARRANTIES FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
** DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
** OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
**
****************************************************************************/
/*!
 * @file  can_definitions.h
 * @brief MCU specific CAN module definitions for DSPIC33EP256MU814.
 */

#ifndef _CAN_DEFINITIONS_H_
#define _CAN_DEFINITIONS_H_

#ifdef __cplusplus
extern "C"{
#endif

// CAN
#define CAN1_RX_RG15_RP127 (127)
#define CAN1_TX_RG15_RP127 (127)
#define CAN2_RX_RG15_RP127 (127)
#define CAN2_TX_RG15_RP127 (127)
#define CAN1_RX_RE5_RP85 (85)
#define CAN1_TX_RE5_RP85 (85)
#define CAN2_RX_RE5_RP85 (85)
#define CAN2_TX_RE5_RP85 (85)
#define CAN1_RX_RE7_RP87 (87)
#define CAN1_TX_RE7_RP87 (87)
#define CAN2_RX_RE7_RP87 (87)
#define CAN2_TX_RE7_RP87 (87)
#define CAN1_RX_RG6_RP118 (118)
#define CAN1_TX_RG6_RP118 (118)
#define CAN2_RX_RG6_RP118 (118)
#define CAN2_TX_RG6_RP118 (118)
#define CAN1_RX_RG8_RP120 (120)
#define CAN1_TX_RG8_RP120 (120)
#define CAN2_RX_RG8_RP120 (120)
#define CAN2_TX_RG8_RP120 (120)
#define CAN1_RX_RF13_RP109 (109)
#define CAN1_TX_RF13_RP109 (109)
#define CAN2_RX_RF13_RP109 (109)
#define CAN2_TX_RF13_RP109 (109)
#define CAN1_RX_RF12_RP108 (108)
#define CAN1_TX_RF12_RP108 (108)
#define CAN2_RX_RF12_RP108 (108)
#define CAN2_TX_RF12_RP108 (108)
#define CAN1_RX_RD15_RP79 (79)
#define CAN1_TX_RD15_RP79 (79)
#define CAN2_RX_RD15_RP79 (79)
#define CAN2_TX_RD15_RP79 (79)
#define CAN1_RX_RF4_RP100 (100)
#define CAN1_TX_RF4_RP100 (100)
#define CAN2_RX_RF4_RP100 (100)
#define CAN2_TX_RF4_RP100 (100)
#define CAN1_RX_RF5_RP101 (101)
#define CAN1_TX_RF5_RP101 (101)
#define CAN2_RX_RF5_RP101 (101)
#define CAN2_TX_RF5_RP101 (101)
#define CAN1_RX_RF3_RP99 (99)
#define CAN1_TX_RF3_RP99 (99)
#define CAN2_RX_RF3_RP99 (99)
#define CAN2_TX_RF3_RP99 (99)
#define CAN1_RX_RF2_RP98 (98)
#define CAN1_TX_RF2_RP98 (98)
#define CAN2_RX_RF2_RP98 (98)
#define CAN2_TX_RF2_RP98 (98)
#define CAN1_RX_RF8_RP104 (104)
#define CAN1_TX_RF8_RP104 (104)
#define CAN2_RX_RF8_RP104 (104)
#define CAN2_TX_RF8_RP104 (104)
#define CAN1_RX_RD0_RP64 (64)
#define CAN1_TX_RD0_RP64 (64)
#define CAN2_RX_RD0_RP64 (64)
#define CAN2_TX_RD0_RP64 (64)
#define CAN1_RX_RD1_RP65 (65)
#define CAN1_TX_RD1_RP65 (65)
#define CAN2_RX_RD1_RP65 (65)
#define CAN2_TX_RD1_RP65 (65)
#define CAN1_RX_RD2_RP66 (66)
#define CAN1_TX_RD2_RP66 (66)
#define CAN2_RX_RD2_RP66 (66)
#define CAN2_TX_RD2_RP66 (66)
#define CAN1_RX_RD3_RP67 (67)
#define CAN1_TX_RD3_RP67 (67)
#define CAN2_RX_RD3_RP67 (67)
#define CAN2_TX_RD3_RP67 (67)
#define CAN1_RX_RD4_RP68 (68)
#define CAN1_TX_RD4_RP68 (68)
#define CAN2_RX_RD4_RP68 (68)
#define CAN2_TX_RD4_RP68 (68)
#define CAN1_RX_RD5_RP69 (69)
#define CAN1_TX_RD5_RP69 (69)
#define CAN2_RX_RD5_RP69 (69)
#define CAN2_TX_RD5_RP69 (69)
#define CAN1_RX_RD6_RP70 (70)
#define CAN1_TX_RD6_RP70 (70)
#define CAN2_RX_RD6_RP70 (70)
#define CAN2_TX_RD6_RP70 (70)
#define CAN1_RX_RD7_RP71 (71)
#define CAN1_TX_RD7_RP71 (71)
#define CAN2_RX_RD7_RP71 (71)
#define CAN2_TX_RD7_RP71 (71)
#define CAN1_RX_RF0_RP96 (96)
#define CAN1_TX_RF0_RP96 (96)
#define CAN2_RX_RF0_RP96 (96)
#define CAN2_TX_RF0_RP96 (96)
#define CAN1_RX_RF1_RP97 (97)
#define CAN1_TX_RF1_RP97 (97)
#define CAN2_RX_RF1_RP97 (97)
#define CAN2_TX_RF1_RP97 (97)
#define CAN1_RX_RG1_RP113 (113)
#define CAN1_TX_RG1_RP113 (113)
#define CAN2_RX_RG1_RP113 (113)
#define CAN2_TX_RG1_RP113 (113)
#define CAN1_RX_RG0_RP112 (112)
#define CAN1_TX_RG0_RP112 (112)
#define CAN2_RX_RG0_RP112 (112)
#define CAN2_TX_RG0_RP112 (112)
#define CAN1_RX_RE0_RP80 (80)
#define CAN1_TX_RE0_RP80 (80)
#define CAN2_RX_RE0_RP80 (80)
#define CAN2_TX_RE0_RP80 (80)
#define CAN1_RX_RG14_RP126 (126)
#define CAN1_TX_RG14_RP126 (126)
#define CAN2_RX_RG14_RP126 (126)
#define CAN2_TX_RG14_RP126 (126)
#define CAN1_RX_RG13_RP125 (125)
#define CAN1_TX_RG13_RP125 (125)
#define CAN2_RX_RG13_RP125 (125)
#define CAN2_TX_RG13_RP125 (125)
#define CAN1_RX_RE2_RP82 (82)
#define CAN1_TX_RE2_RP82 (82)
#define CAN2_RX_RE2_RP82 (82)
#define CAN2_TX_RE2_RP82 (82)
#define CAN1_RX_RE4_RP84 (84)
#define CAN1_TX_RE4_RP84 (84)
#define CAN2_RX_RE4_RP84 (84)
#define CAN2_TX_RE4_RP84 (84)
#define CAN1_RX_RE6_RPI86 (86)
#define CAN2_RX_RE6_RPI86 (86)
#define CAN1_RX_RC1_RPI49 (49)
#define CAN2_RX_RC1_RPI49 (49)
#define CAN1_RX_RC2_RPI50 (50)
#define CAN2_RX_RC2_RPI50 (50)
#define CAN1_RX_RC3_RPI51 (51)
#define CAN2_RX_RC3_RPI51 (51)
#define CAN1_RX_RC4_RPI52 (52)
#define CAN2_RX_RC4_RPI52 (52)
#define CAN1_RX_RG7_RPI119 (119)
#define CAN2_RX_RG7_RPI119 (119)
#define CAN1_RX_RG9_RPI121 (121)
#define CAN2_RX_RG9_RPI121 (121)
#define CAN1_RX_RA0_RPI16 (16)
#define CAN2_RX_RA0_RPI16 (16)
#define CAN1_RX_RE8_RPI88 (88)
#define CAN2_RX_RE8_RPI88 (88)
#define CAN1_RX_RE9_RPI89 (89)
#define CAN2_RX_RE9_RPI89 (89)
#define CAN1_RX_RB5_RPI37 (37)
#define CAN2_RX_RB5_RPI37 (37)
#define CAN1_RX_RB4_RPI36 (36)
#define CAN2_RX_RB4_RPI36 (36)
#define CAN1_RX_RB3_RPI35 (35)
#define CAN2_RX_RB3_RPI35 (35)
#define CAN1_RX_RB2_RPI34 (34)
#define CAN2_RX_RB2_RPI34 (34)
#define CAN1_RX_RB1_RPI33 (33)
#define CAN2_RX_RB1_RPI33 (33)
#define CAN1_RX_RB0_RPI32 (32)
#define CAN2_RX_RB0_RPI32 (32)
#define CAN1_RX_RB6_RPI38 (38)
#define CAN2_RX_RB6_RPI38 (38)
#define CAN1_RX_RB7_RPI39 (39)
#define CAN2_RX_RB7_RPI39 (39)
#define CAN1_RX_RB8_RPI40 (40)
#define CAN2_RX_RB8_RPI40 (40)
#define CAN1_RX_RB9_RPI41 (41)
#define CAN2_RX_RB9_RPI41 (41)
#define CAN1_RX_RB10_RPI42 (42)
#define CAN2_RX_RB10_RPI42 (42)
#define CAN1_RX_RB11_RPI43 (43)
#define CAN2_RX_RB11_RPI43 (43)
#define CAN1_RX_RA1_RPI17 (17)
#define CAN2_RX_RA1_RPI17 (17)
#define CAN1_RX_RB12_RPI44 (44)
#define CAN2_RX_RB12_RPI44 (44)
#define CAN1_RX_RB13_RPI45 (45)
#define CAN2_RX_RB13_RPI45 (45)
#define CAN1_RX_RB14_RPI46 (46)
#define CAN2_RX_RB14_RPI46 (46)
#define CAN1_RX_RB15_RPI47 (47)
#define CAN2_RX_RB15_RPI47 (47)
#define CAN1_RX_RD14_RPI78 (78)
#define CAN2_RX_RD14_RPI78 (78)
#define CAN1_RX_RA2_RPI18 (18)
#define CAN2_RX_RA2_RPI18 (18)
#define CAN1_RX_RA3_RPI19 (19)
#define CAN2_RX_RA3_RPI19 (19)
#define CAN1_RX_RA4_RPI20 (20)
#define CAN2_RX_RA4_RPI20 (20)
#define CAN1_RX_RA5_RPI21 (21)
#define CAN2_RX_RA5_RPI21 (21)
#define CAN1_RX_RC12_RPI60 (60)
#define CAN2_RX_RC12_RPI60 (60)
#define CAN1_RX_RA14_RPI30 (30)
#define CAN2_RX_RA14_RPI30 (30)
#define CAN1_RX_RA15_RPI31 (31)
#define CAN2_RX_RA15_RPI31 (31)
#define CAN1_RX_RD8_RPI72 (72)
#define CAN2_RX_RD8_RPI72 (72)
#define CAN1_RX_RD9_RPI73 (73)
#define CAN2_RX_RD9_RPI73 (73)
#define CAN1_RX_RD10_RPI74 (74)
#define CAN2_RX_RD10_RPI74 (74)
#define CAN1_RX_RD11_RPI75 (75)
#define CAN2_RX_RD11_RPI75 (75)
#define CAN1_RX_RC13_RPI61 (61)
#define CAN2_RX_RC13_RPI61 (61)
#define CAN1_RX_RC14_RPI62 (62)
#define CAN2_RX_RC14_RPI62 (62)
#define CAN1_RX_RD12_RPI76 (76)
#define CAN2_RX_RD12_RPI76 (76)
#define CAN1_RX_RD13_RPI77 (77)
#define CAN2_RX_RD13_RPI77 (77)
#define CAN1_RX_RA6_RPI22 (22)
#define CAN2_RX_RA6_RPI22 (22)
#define CAN1_RX_RA7_RPI23 (23)
#define CAN2_RX_RA7_RPI23 (23)
#define CAN1_RX_RE1_RPI81 (81)
#define CAN2_RX_RE1_RPI81 (81)
#define CAN1_RX_RG12_RPI124 (124)
#define CAN2_RX_RG12_RPI124 (124)
#define CAN1_RX_RE3_RPI83 (83)
#define CAN2_RX_RE3_RPI83 (83)

#define CAN_MODULE_1 (1)
#define CAN_MODULE_2 (2)

#define CAN_MODULE_COUNT (2)

#define HAL_LL_C1CTRL1_ADDRESS (0x400U)
#define HAL_LL_CAN1_BASE_ADDRESS HAL_LL_C1CTRL1_ADDRESS
#define HAL_LL_C1RXFUL1_ADDRESS (0x420U)
#define HAL_LL_CAN1_ALTERNATE_BASE_ADDRESS HAL_LL_C1RXFUL1_ADDRESS
#define HAL_LL_C2CTRL1_ADDRESS (0x500U)
#define HAL_LL_CAN2_BASE_ADDRESS HAL_LL_C2CTRL1_ADDRESS
#define HAL_LL_C2RXFUL1_ADDRESS (0x520U)
#define HAL_LL_CAN2_ALTERNATE_BASE_ADDRESS HAL_LL_C2RXFUL1_ADDRESS
#define HAL_LL_DMA0CON_ADDRESS (0xB00U)
#define HAL_LL_DMA_BASE_ADDRESS HAL_LL_DMA0CON_ADDRESS
#define HAL_LL_DMA_RAM_TX_ADDRESS (0x7000U)
#define HAL_LL_DMA_RAM_RX_ADDRESS (HAL_LL_DMA_RAM_TX_ADDRESS + 0x10U)

#define HAL_LL_CAN_PPS_ENABLED true
// EOF CAN

#ifdef __cplusplus
}
#endif

#endif // _CAN_DEFINITIONS_H_
// ------------------------------------------------------------------------- END
